"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var styled_1 = require("@emotion/styled");
var faCheck_1 = require("@fortawesome/free-solid-svg-icons/faCheck");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var React = require("react");
var recompose_1 = require("recompose");
var WithComponentTheme_1 = require("../../util/enhancers/WithComponentTheme");
var Clickable_1 = require("../interaction/Clickable");
var Space_1 = require("../layout/Space");
var ProgressIndicator_1 = require("../progress/ProgressIndicator");
var ButtonText = styled_1.default('span')({
    fontWeight: 600,
    letterSpacing: '1px',
}, function (_a) {
    var color = _a.color, fontFamily = _a.fontFamily, fontSize = _a.fontSize;
    return ({
        fontSize: fontSize,
        color: color,
        fontFamily: fontFamily,
    });
});
var StyledButton = styled_1.default.button(templateObject_1 || (templateObject_1 = tslib_1.__makeTemplateObject(["\n  align-items: center;\n  display: flex;\n  flex-direction: row;\n  justify-content: center;\n  background-color: ", ";\n  height: ", ";\n  width: ", ";\n  cursor: ", ";\n\n  border: 1px solid ", ";\n  border-radius: ", ";\n  overflow: hidden;\n\n  padding: 0;\n  font: inherit;\n  color: inherit;\n  outline: none;\n\n  :focus {\n    box-shadow: 0 2px 15px 0 rgba(0, 0, 0, 0.15);\n  }\n"], ["\n  align-items: center;\n  display: flex;\n  flex-direction: row;\n  justify-content: center;\n  background-color: ", ";\n  height: ", ";\n  width: ", ";\n  cursor: ", ";\n\n  border: 1px solid ", ";\n  border-radius: ", ";\n  overflow: hidden;\n\n  padding: 0;\n  font: inherit;\n  color: inherit;\n  outline: none;\n\n  :focus {\n    box-shadow: 0 2px 15px 0 rgba(0, 0, 0, 0.15);\n  }\n"])), function (_a) {
    var backgroundColor = _a.backgroundColor;
    return backgroundColor;
}, function (_a) {
    var height = _a.height;
    return height;
}, function (_a) {
    var width = _a.width;
    return width;
}, function (_a) {
    var disabled = _a.disabled;
    return (disabled ? 'inherit' : 'pointer');
}, function (_a) {
    var backgroundColor = _a.backgroundColor;
    return backgroundColor;
}, function (_a) {
    var borderRadius = _a.borderRadius;
    return borderRadius;
});
var ButtonComponent = /** @class */ (function (_super) {
    tslib_1.__extends(ButtonComponent, _super);
    function ButtonComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ButtonComponent.prototype.renderButton = function () {
        var _a = this.props, color = _a.color, disabledColor = _a.disabledColor, textColor = _a.textColor, label = _a.label, left = _a.left, right = _a.right, leftIcon = _a.leftIcon, rightIcon = _a.rightIcon, width = _a.width, height = _a.height, _b = _a.disabled, disabled = _b === void 0 ? false : _b, _c = _a.loading, loading = _c === void 0 ? false : _c, _d = _a.success, success = _d === void 0 ? false : _d, successText = _a.successText, successIconColor = _a.successIconColor, successTextColor = _a.successTextColor, _e = _a.iconSize, iconSize = _e === void 0 ? 14 : _e, borderRadius = _a.borderRadius, theme = _a.theme;
        return (React.createElement(StyledButton, { backgroundColor: disabled
                ? disabledColor || theme.bgColorDisabled
                : color || theme.bgColor, borderRadius: borderRadius || theme.borderRadius || '0', disabled: disabled, height: height || '100%', width: width || '100%' },
            React.createElement(Space_1.Space, { num: theme.numSpacing }),
            !loading &&
                !success &&
                (leftIcon || left) && (React.createElement(React.Fragment, null,
                leftIcon && (React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: leftIcon, color: textColor || theme.textColor, style: { fontSize: iconSize } })),
                left || undefined,
                label && React.createElement(Space_1.Space, { num: 2 }))),
            success &&
                successText && (React.createElement(React.Fragment, null,
                React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faCheck_1.faCheck, color: successIconColor || theme.successIconColor, style: { fontSize: iconSize, marginRight: '9px' } }),
                React.createElement(ButtonText, { color: successTextColor || theme.successTextColor, fontSize: theme.fontSize, fontFamily: theme.font }, successText))),
            !loading &&
                !success &&
                label && (React.createElement(ButtonText, { color: textColor || theme.textColor, fontSize: theme.fontSize, fontFamily: theme.font }, label)),
            loading && (React.createElement(ProgressIndicator_1.ProgressIndicator, { small: true, color: textColor || theme.textColor, backgroundColor: color || theme.bgColor })),
            success &&
                !successText && (React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faCheck_1.faCheck, color: successIconColor || theme.successIconColor, style: { fontSize: 20 } })),
            !loading &&
                !success &&
                (rightIcon || right) && (React.createElement(React.Fragment, null,
                label && React.createElement(Space_1.Space, { num: 2 }),
                right,
                rightIcon && (React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: rightIcon, color: textColor || theme.textColor, style: { fontSize: iconSize } })))),
            React.createElement(Space_1.Space, { num: theme.numSpacing })));
    };
    ButtonComponent.prototype.render = function () {
        var _a = this.props, disabled = _a.disabled, onClick = _a.onClick;
        if (disabled) {
            return (React.createElement("div", { style: { display: 'inline-block' } }, this.renderButton()));
        }
        return (React.createElement(Clickable_1.Clickable, { onClick: onClick, opacityOnHover: true }, this.renderButton()));
    };
    return ButtonComponent;
}(React.PureComponent));
exports.Button = recompose_1.compose(WithComponentTheme_1.withComponentTheme('Button'))(ButtonComponent);
var templateObject_1;
//# sourceMappingURL=Button.js.map