import * as React from 'react';
import { CalendarDayProps, CalendarOnClicks, CalendarUserMonthData, DayState, DayStateHighlight, ExtraDayContentProps, Renderers } from '../types/CalendarTypes';
import { MonthData } from '../util/CalendarDataFactory';
import { CalendarTheme } from './CalendarTheme';
export interface CalendarMonthProps<T> extends CalendarOnClicks<T>, Renderers {
    month: MonthData;
    dayComponent: React.ComponentType<CalendarDayProps<T>>;
    userDataPerWeek?: CalendarUserMonthData<T>;
    statePerWeek?: CalendarUserMonthData<DayState>;
    theme: CalendarTheme;
    headerLeftContent?: React.ReactElement<{}>;
    headerRightContent?: React.ReactElement<{}>;
    extraDayContent?: React.ComponentType<ExtraDayContentProps<T>>;
    defaultHighlights?: Array<DayStateHighlight>;
}
export declare class CalendarMonth<T> extends React.Component<CalendarMonthProps<T>> {
    render(): JSX.Element;
}
