"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var layout_1 = require("../../../layout");
var DefaultText_1 = require("../../../text/DefaultText");
var SectionHeaderText_1 = require("../../../text/SectionHeaderText");
var CalendarWeek_1 = require("./CalendarWeek");
var WeekDayCell_1 = require("./renderers/WeekDayCell");
var CalendarMonth = /** @class */ (function (_super) {
    tslib_1.__extends(CalendarMonth, _super);
    function CalendarMonth() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CalendarMonth.prototype.render = function () {
        var _a = this.props, month = _a.month, dayComponent = _a.dayComponent, statePerWeek = _a.statePerWeek, userDataPerWeek = _a.userDataPerWeek, onClickDay = _a.onClickDay, onClickWeek = _a.onClickWeek, onClickWeekDay = _a.onClickWeekDay, renderWeekNumber = _a.renderWeekNumber, renderWeekDay = _a.renderWeekDay, headerLeftContent = _a.headerLeftContent, headerRightContent = _a.headerRightContent, theme = _a.theme, extraDayContent = _a.extraDayContent, defaultHighlights = _a.defaultHighlights;
        return (React.createElement(React.Fragment, null,
            React.createElement(layout_1.Column, { alignItems: 'center' },
                React.createElement("table", { style: { borderSpacing: 0, borderCollapse: 'collapse' } },
                    React.createElement("tbody", null,
                        React.createElement("tr", null,
                            React.createElement("td", null,
                                React.createElement(layout_1.Column, { justifyContent: 'center', alignItems: 'center' }, headerLeftContent)),
                            React.createElement("td", { colSpan: 6 },
                                React.createElement(layout_1.Row, { justifyContent: 'center', alignItems: 'center' },
                                    React.createElement(SectionHeaderText_1.SectionHeaderText, { color: theme.CalendarMonth.headerTextColor },
                                        month.name,
                                        " ",
                                        month.year))),
                            React.createElement("td", null,
                                React.createElement(layout_1.Column, { justifyContent: 'center', alignItems: 'center' }, headerRightContent))),
                        React.createElement("tr", null,
                            React.createElement("td", null,
                                React.createElement(layout_1.Column, { width: theme.width, height: theme.height, justifyContent: 'center', alignItems: 'center' },
                                    React.createElement(DefaultText_1.DefaultText, { color: theme.WeekDay.textColor }, "W"))),
                            month.weeks[0].days.map(function (day, index) { return (React.createElement("td", { key: day.name }, renderWeekDay ? (renderWeekDay(day.name, theme, onClickWeekDay)) : (React.createElement(WeekDayCell_1.WeekDayCell, { day: day, onClickWeekDay: onClickWeekDay, theme: theme })))); })),
                        month.weeks.map(function (week) { return (React.createElement(CalendarWeek_1.CalendarWeek, { key: week.weekNumber, month: month, week: week, dayComponent: dayComponent, statePerWeekDay: statePerWeek && statePerWeek[week.weekNumber], userDataPerWeekDay: userDataPerWeek && userDataPerWeek[week.weekNumber], onClickDay: onClickDay, onClickWeek: onClickWeek, theme: theme, renderWeekNumber: renderWeekNumber, extraDayContent: extraDayContent, defaultHighlights: defaultHighlights })); }))))));
    };
    return CalendarMonth;
}(React.Component));
exports.CalendarMonth = CalendarMonth;
//# sourceMappingURL=CalendarMonth.js.map