import * as React from 'react';
import { CalendarUserWeekData, DayState, DayStateHighlight, ExtraDayContentProps, OnClickDay, OnClickWeek, RenderWeekNumber } from '../types/CalendarTypes';
import { MonthData, WeekData } from '../util/CalendarDataFactory';
import { CalendarDayProps } from '../types/CalendarTypes';
import { CalendarTheme } from './CalendarTheme';
export interface CalendarWeekProps<T> {
    dayComponent: React.ComponentType<CalendarDayProps<T>>;
    week: WeekData;
    month: MonthData;
    statePerWeekDay?: CalendarUserWeekData<DayState>;
    userDataPerWeekDay?: CalendarUserWeekData<T>;
    onClickWeek?: OnClickWeek;
    onClickDay?: OnClickDay<T>;
    theme: CalendarTheme;
    renderWeekNumber?: RenderWeekNumber;
    extraDayContent?: React.ComponentType<ExtraDayContentProps<T>>;
    defaultHighlights?: Array<DayStateHighlight>;
}
export declare const CalendarWeek: <T extends {}>({ week, month, dayComponent: DayComponent, statePerWeekDay, userDataPerWeekDay, onClickWeek, onClickDay, theme, renderWeekNumber, extraDayContent, defaultHighlights, }: CalendarWeekProps<T>) => JSX.Element;
