"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var interaction_1 = require("../../../../interaction");
var layout_1 = require("../../../../layout");
var text_1 = require("../../../../text");
var StateHelper_1 = require("../../util/StateHelper");
exports.CalendarDay = function (_a) {
    var day = _a.day, week = _a.week, month = _a.month, dayState = _a.dayState, userData = _a.userData, onClickDay = _a.onClickDay, theme = _a.theme, ExtraDayContent = _a.extraDayContent, defaultHighlights = _a.defaultHighlights;
    return (React.createElement("td", { style: tslib_1.__assign({}, (theme.CalendarDay.wrapperStyle &&
            theme.CalendarDay.wrapperStyle(defaultHighlights, dayState, day, week, month, userData)), { width: theme.width, height: theme.height }) },
        React.createElement("div", { style: tslib_1.__assign({}, (theme.CalendarDay.innerWrapperStyle &&
                theme.CalendarDay.innerWrapperStyle(defaultHighlights, dayState, day, week, month, userData)), { width: '100%', height: '100%' }) },
            React.createElement("div", { style: tslib_1.__assign({}, (theme.CalendarDay.cellWrapperStyle &&
                    theme.CalendarDay.cellWrapperStyle(defaultHighlights, dayState, day, week, month, userData)), { width: '100%', height: '100%', position: 'relative' }) },
                ExtraDayContent && (React.createElement(ExtraDayContent, { week: week, month: month, day: day, dayState: dayState, theme: theme, userData: userData })),
                React.createElement(interaction_1.Clickable, { onClick: onClickDay &&
                        day.month === month.monthInYear &&
                        isClickable(defaultHighlights, dayState)
                        ? function () { return onClickDay(day, userData); }
                        : undefined, style: { width: '100%', height: '100%' } },
                    React.createElement(layout_1.Column, { width: '100%', height: '100%', justifyContent: 'center', alignItems: 'center' },
                        React.createElement(text_1.DefaultText, tslib_1.__assign({}, theme.CalendarDay.textProps &&
                            theme.CalendarDay.textProps(defaultHighlights, dayState, day, week, month, userData)), day.dayOfMonth)))))));
};
var isClickable = function (defaultHighlights, dayState) {
    return !!StateHelper_1.dayHighlightSelect(dayState, defaultHighlights, ['enabled', 'disabled'], [true, false], true);
};
//# sourceMappingURL=CalendarDay.js.map