import { ComponentEnhancer } from 'recompose';
import { Omit } from '../../../../../types/Omit';
import { CalendarProps } from '../types/CalendarTypes';
import { CalendarUserData } from '../types/CalendarTypes';
import { WithCalendarTheme } from '../types/WithCalendarTheme';
import { WithMonthSwitcherProps } from './month-switcher/MonthSwitcher';
import { MonthSwitcherLogicOuterProps } from './month-switcher/MonthSwitcherLogic';
export declare type __C359813518 = ComponentEnhancer<{}, {}>;
export declare type DateRangeFocusedInput = 'startDate' | 'endDate' | undefined;
export declare type DateRangeCalendarProps<T> = Omit<CalendarProps<T>, 'theme'> & MonthSwitcherLogicOuterProps & DateRangeCalendarState & OnChangePropsDateRangeSelection & WithCalendarTheme & WithMonthSwitcherProps;
export declare type DateRangeCalendarPropsWithStateProps<T> = Omit<CalendarProps<T>, 'theme'> & OnChangePropsDateRangeSelection & WithCalendarTheme & WithMonthSwitcherProps;
export interface DateRangeCalendarState {
    startDate: Date | undefined;
    endDate: Date | undefined;
    focusedInput?: DateRangeFocusedInput;
    setStartDate: (startDate: Date) => void;
    setEndDate: (endDate: Date) => void;
    setFocusedInput: (focusedInput: DateRangeFocusedInput) => void;
}
export interface DateRangeCalendarOnChangeValue {
    startDate?: Date;
    endDate?: Date;
}
export interface OnChangePropsDateRangeSelection {
    /** onChange handler for when the user selects a date. */
    onChange?: (value: DateRangeCalendarOnChangeValue) => void;
}
export declare const buildDayState: (statePerMonth?: CalendarUserData<import("../types/CalendarTypes").HighlightsState>, start?: Date | undefined, end?: Date | undefined) => CalendarUserData<import("../types/CalendarTypes").HighlightsState> | undefined;
export declare const withDateRangeSelectionState: ComponentEnhancer<{}, {}>;
export declare const withDateRangeSelection: ComponentEnhancer<{}, {}>;
