"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var recompose_1 = require("recompose");
var StateModifier_1 = require("../util/StateModifier");
var addSelectionLogic = recompose_1.withHandlers({
    onClickDay: function (_a) {
        var onChange = _a.onChange;
        return function (day) {
            if (onChange) {
                onChange(day.date);
            }
        };
    },
});
var buildSelectionState = recompose_1.withProps(function (_a) {
    var value = _a.value, statePerMonth = _a.statePerMonth;
    return {
        statePerMonth: value
            ? StateModifier_1.addDayStateHighlights(statePerMonth, value, ['selected'])
            : statePerMonth,
        date: value,
        startDateInFocus: value,
    };
});
exports.withSingleDateSelection = recompose_1.compose(addSelectionLogic, recompose_1.pure, buildSelectionState);
//# sourceMappingURL=SingleDateSelection.js.map