"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var date_fns_1 = require("date-fns");
var recompose_1 = require("recompose");
var withClickHandlers = recompose_1.withHandlers({
    nextMonth: function (_a) {
        var setDate = _a.setDate, date = _a.date, monthsPerRow = _a.monthsPerRow, numMonths = _a.numMonths;
        return function () {
            setDate(date_fns_1.addMonths(date, monthsPerRow || numMonths || 1));
        };
    },
    prevMonth: function (_a) {
        var setDate = _a.setDate, date = _a.date, monthsPerRow = _a.monthsPerRow, numMonths = _a.numMonths;
        return function () {
            setDate(date_fns_1.subMonths(date, monthsPerRow || numMonths || 1));
        };
    },
});
var withDateInFocusState = recompose_1.withState('date', 'setDate', function (_a) {
    var startDateInFocus = _a.startDateInFocus;
    return startDateInFocus || new Date();
});
exports.withMonthSwitcherLogic = recompose_1.compose(withDateInFocusState, withClickHandlers);
//# sourceMappingURL=MonthSwitcherLogic.js.map