export declare enum Months {
    JANUARY = 0,
    FEBRUARY = 1,
    MARCH = 2,
    APRIL = 3,
    MAY = 4,
    JUNE = 5,
    JULY = 6,
    AUGUST = 7,
    SEPTEMBER = 8,
    OCTOBER = 9,
    NOVEMBER = 10,
    DECEMBER = 11
}
export declare enum WeekDays {
    SUNDAY = 0,
    MONDAY = 1,
    TUESDAY = 2,
    WEDNESDAY = 3,
    THURSDAY = 4,
    FRIDAY = 5,
    SATURDAY = 6
}
export interface DayData {
    name: string;
    date: Date;
    dateString: string;
    weekNumber: number;
    year: number;
    month: number;
    dayOfMonth: number;
    dayOfWeek: number;
    isFirstDayOfWeek: boolean;
    isLastDayOfWeek: boolean;
    isFirstDayOfMonth: boolean;
    isLastDayOfMonth: boolean;
}
export interface WeekData {
    weekNumber: number;
    startMonth: number;
    startYear: number;
    endMonth: number;
    endYear: number;
    isLastWeekOfMonth: boolean;
    days: Array<DayData>;
}
export interface MonthData {
    monthString: string;
    name: string;
    year: number;
    monthInYear: number;
    weeks: Array<WeekData>;
}
export declare const getMonthsInYear: (year: number, startMonth: number, numMonths: number) => MonthData[];
export declare const getMonthInYear: (year: number, month: number) => MonthData;
export declare const getWeeksForMonth: (year: number, month: number, forceSixWeeks?: boolean) => WeekData[];
export declare const getWeekForDate: (firstDayOfWeek: Date) => WeekData;
export declare const createDay: (date: Date) => DayData;
export declare const getDaysForWeekForDate: (firstDayOfWeek: Date) => DayData[];
export declare const getStartDateOfISOWeek: (weekNumber: number, year: number) => Date;
export declare const calculateOverflowingMonth: (year: number, month: number) => {
    year: number;
    month: number;
};
