"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var date_fns_1 = require("date-fns");
var DateFormats_1 = require("../../../../../util/date/DateFormats");
exports.transformDateIntervalToDateStringInterval = function (interval) { return ({
    startDate: interval.startDate && date_fns_1.format(interval.startDate, DateFormats_1.DateFormats.fullDate),
    endDate: interval.endDate && date_fns_1.format(interval.endDate, DateFormats_1.DateFormats.fullDate),
}); };
exports.transformDateStringIntervalToDateInterval = function (interval) {
    var now = new Date();
    return {
        startDate: (interval.startDate &&
            date_fns_1.parse(interval.startDate, DateFormats_1.DateFormats.fullDate, now)) ||
            undefined,
        endDate: (interval.endDate &&
            date_fns_1.parse(interval.endDate, DateFormats_1.DateFormats.fullDate, now)) ||
            undefined,
    };
};
exports.ensureStartIsFirst = function (interval) {
    if (interval.startDate &&
        interval.endDate &&
        date_fns_1.isAfter(interval.startDate, interval.endDate)) {
        return {
            startDate: interval.endDate,
            endDate: interval.startDate,
        };
    }
    return interval;
};
//# sourceMappingURL=CalendarIntervalValidator.js.map