"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.dayHasHighlight = function (dayState, defaultHighlights, highlight) {
    if (defaultHighlights && defaultHighlights.indexOf(highlight) >= 0) {
        return true;
    }
    if (dayState &&
        dayState.highlights &&
        dayState.highlights.indexOf(highlight) >= 0) {
        return true;
    }
    return false;
};
exports.dayHighlightSelect = function (dayState, defaultHighlights, highlightsOrBoolean, returnValues, fallbackValue) {
    if (highlightsOrBoolean.length !== returnValues.length) {
        throw new Error('Select highlight failed, number of values do not equal number of highlights.');
    }
    if (highlightsOrBoolean.length === 0) {
        return fallbackValue;
    }
    for (var i = 0; i < highlightsOrBoolean.length; i++) {
        if (typeof highlightsOrBoolean[i] === 'boolean' && highlightsOrBoolean[i]) {
            return returnValues[i];
        }
        if (typeof highlightsOrBoolean[i] === 'string' &&
            exports.dayHasHighlight(dayState, defaultHighlights, highlightsOrBoolean[i])) {
            return returnValues[i];
        }
    }
    return fallbackValue;
};
//# sourceMappingURL=StateHelper.js.map