"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var date_fns_1 = require("date-fns");
var DateFormats_1 = require("../../../../../util/date/DateFormats");
exports.setDayStateValue = function (state, date, values) {
    var _a, _b, _c;
    var monthString = date_fns_1.format(date, DateFormats_1.DateFormats.yearAndMonth);
    var weekNumber = date_fns_1.getISOWeek(date);
    var dayInMonth = date_fns_1.getDate(date);
    return tslib_1.__assign({}, state, (_a = {}, _a[monthString] = tslib_1.__assign({}, (state && state[monthString]), (_b = {}, _b[weekNumber] = tslib_1.__assign({}, (state && state[monthString] && state[monthString][weekNumber]), (_c = {}, _c[dayInMonth] = tslib_1.__assign({}, (state &&
        state[monthString] &&
        state[monthString][weekNumber] &&
        state[monthString][weekNumber][dayInMonth]), values), _c)), _b)), _a));
};
exports.setDayStateValueFunction = function (state, date, setter) {
    var _a, _b, _c;
    var monthString = date_fns_1.format(date, DateFormats_1.DateFormats.yearAndMonth);
    var weekNumber = date_fns_1.getISOWeek(date);
    var dayInMonth = date_fns_1.getDate(date);
    return tslib_1.__assign({}, state, (_a = {}, _a[monthString] = tslib_1.__assign({}, (state && state[monthString]), (_b = {}, _b[weekNumber] = tslib_1.__assign({}, (state && state[monthString] && state[monthString][weekNumber]), (_c = {}, _c[dayInMonth] = tslib_1.__assign({}, (state &&
        state[monthString] &&
        state[monthString][weekNumber] &&
        state[monthString][weekNumber][dayInMonth]), setter(state &&
        state[monthString] &&
        state[monthString][weekNumber] &&
        state[monthString][weekNumber][dayInMonth])), _c)), _b)), _a));
};
exports.addDayStateHighlights = function (calendarState, date, highlights) {
    var _a, _b, _c;
    var month = date.getMonth() + 1;
    var monthString = date.getFullYear() + "-" + (month < 10 ? '0' : '') + month;
    var weekNumber = date_fns_1.getISOWeek(date);
    var dayInMonth = date_fns_1.getDate(date);
    var dayState = calendarState &&
        calendarState[monthString] &&
        calendarState[monthString][weekNumber] &&
        calendarState[monthString][weekNumber][dayInMonth];
    var newHighlights = dayState && dayState.highlights
        ? dayState.highlights.concat(highlights) : highlights;
    return tslib_1.__assign({}, calendarState, (_a = {}, _a[monthString] = tslib_1.__assign({}, (calendarState && calendarState[monthString]), (_b = {}, _b[weekNumber] = tslib_1.__assign({}, (calendarState &&
        calendarState[monthString] &&
        calendarState[monthString][weekNumber]), (_c = {}, _c[dayInMonth] = tslib_1.__assign({}, dayState, { highlights: newHighlights }), _c)), _b)), _a));
};
exports.addWeekStateHighlights = function (calendarState, week, highlights) {
    var _a, _b;
    var date = week.days[0].date;
    var month = date.getMonth() + 1;
    var monthString = date.getFullYear() + "-" + (month < 10 ? '0' : '') + month;
    var weekNumber = week.weekNumber;
    var state = calendarState;
    week.days.forEach(function (day) {
        state = exports.addDayStateHighlights(state, day.date, highlights);
    });
    var weekState = state && state[monthString] ? state[monthString][weekNumber] : undefined;
    var newHighlights = weekState && weekState.highlights
        ? weekState.highlights.concat(highlights) : highlights;
    var newWeekState = tslib_1.__assign({}, weekState, { highlights: newHighlights });
    return tslib_1.__assign({}, state, (_a = {}, _a[monthString] = tslib_1.__assign({}, (calendarState && calendarState[monthString]), (_b = {}, _b[weekNumber] = newWeekState, _b)), _a));
};
//# sourceMappingURL=StateModifier.js.map