"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var recompose_1 = require("recompose");
var WithComponentTheme_1 = require("../../../util/enhancers/WithComponentTheme");
var withOnToggleHandler_1 = require("../../../util/enhancers/withOnToggleHandler");
var Clickable_1 = require("../../interaction/Clickable");
var Row_1 = require("../../layout/Row");
var Space_1 = require("../../layout/Space");
var DefaultText_1 = require("../../text/DefaultText");
var SimpleCheckbox_1 = require("./SimpleCheckbox");
exports.CheckboxWithLabelComponent = function (props) {
    var children = props.children, disabled = props.disabled, label = props.label, onChange = props.onChange, // Do not pass to SimpleCheckbox
    onToggle = props.onToggle, innerRef = props.innerRef, textColor = props.textColor, theme = props.theme, propsToCheckbox = tslib_1.__rest(props, ["children", "disabled", "label", "onChange", "onToggle", "innerRef", "textColor", "theme"]);
    return (React.createElement("div", { ref: innerRef },
        React.createElement(Clickable_1.Clickable, { onClick: disabled ? undefined : onToggle },
            React.createElement(Row_1.Row, { alignItems: 'center' },
                React.createElement(SimpleCheckbox_1.SimpleCheckbox, tslib_1.__assign({}, propsToCheckbox, { disabled: disabled })),
                React.createElement(Space_1.Space, null),
                label && (React.createElement(DefaultText_1.DefaultText, { color: disabled ? theme.disabledColors.iconColor : textColor }, label)),
                children))));
};
exports.CheckboxWithLabel = recompose_1.setDisplayName('CheckboxWithLabel')(recompose_1.compose(WithComponentTheme_1.withComponentTheme('SimpleCheckbox'), withOnToggleHandler_1.withOnToggleHandler)(exports.CheckboxWithLabelComponent));
//# sourceMappingURL=CheckboxWithLabel.js.map