import * as React from 'react';
import { DeepPartial } from '../../../../types/DeepPartial';
import { RequiredInputComponentProps } from '../../../RequiredComponentProps';
import { WithInnerComponentThemeProps } from '../../../util/enhancers/WithComponentTheme';
import { ValueOnChangeProps } from '../types';
import { SimpleCheckboxTheme } from './SimpleCheckboxTheme';
export interface SimpleCheckboxProps extends ValueOnChangeProps<boolean>, RequiredInputComponentProps<HTMLDivElement, HTMLInputElement> {
    disabled?: boolean;
    indeterminate?: boolean;
    theme?: DeepPartial<SimpleCheckboxTheme>;
}
declare type InnerProps = SimpleCheckboxProps & WithInnerComponentThemeProps<SimpleCheckboxTheme>;
export declare const SimpleCheckboxComponent: React.FC<InnerProps>;
export declare const SimpleCheckbox: React.ComponentClass<SimpleCheckboxProps, any>;
export {};
