"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var styled_1 = require("@emotion/styled");
var faMinus_1 = require("@fortawesome/free-solid-svg-icons/faMinus");
var React = require("react");
var react_1 = require("react");
var recompose_1 = require("recompose");
var WithComponentTheme_1 = require("../../../util/enhancers/WithComponentTheme");
var Icon_1 = require("../../icon/Icon");
var Clickable_1 = require("../../interaction/Clickable");
var Row_1 = require("../../layout/Row");
var InvisibleInput = styled_1.default.input(templateObject_1 || (templateObject_1 = tslib_1.__makeTemplateObject(["\n  top: 0;\n  left: 0;\n  width: 100%;\n  cursor: inherit;\n  height: 100%;\n  margin: 0;\n  opacity: 0;\n  padding: 0;\n  position: absolute;\n"], ["\n  top: 0;\n  left: 0;\n  width: 100%;\n  cursor: inherit;\n  height: 100%;\n  margin: 0;\n  opacity: 0;\n  padding: 0;\n  position: absolute;\n"])));
var resolveColor = function (_a, type) {
    var disabled = _a.disabled, indeterminate = _a.indeterminate, theme = _a.theme, value = _a.value;
    if (disabled) {
        return theme.disabledColors[type];
    }
    else if (value || indeterminate) {
        return theme.checkedColors[type];
    }
    else {
        return theme.colors[type];
    }
};
var Wrapper = styled_1.default('div')(templateObject_2 || (templateObject_2 = tslib_1.__makeTemplateObject(["\n  background-color: ", ";\n  border-radius: ", ";\n  border: 1px solid ", ";\n  overflow: hidden;\n"], ["\n  background-color: ", ";\n  border-radius: ", ";\n  border: 1px solid ", ";\n  overflow: hidden;\n"])), function (props) { return resolveColor(props, 'backgroundColor'); }, function (_a) {
    var theme = _a.theme;
    return theme.borderRadius;
}, function (props) { return resolveColor(props, 'borderColor'); });
var StyledSimpleCheckboxWrapper = styled_1.default.div(templateObject_3 || (templateObject_3 = tslib_1.__makeTemplateObject(["\n  height: ", ";\n  position: relative;\n  width: ", ";\n\n  input:focus + div {\n    border-color: ", ";\n  }\n"], ["\n  height: ", ";\n  position: relative;\n  width: ", ";\n\n  input:focus + div {\n    border-color: ", ";\n  }\n"])), function (_a) {
    var theme = _a.theme;
    return theme.height;
}, function (_a) {
    var theme = _a.theme;
    return theme.width;
}, function (_a) {
    var theme = _a.theme;
    return theme.borderColorFocused;
});
exports.SimpleCheckboxComponent = function (_a) {
    var className = _a.className, disabled = _a.disabled, inputRef = _a.inputRef, indeterminate = _a.indeterminate, onChange = _a.onChange, innerRef = _a.innerRef, theme = _a.theme, value = _a.value;
    var ref = react_1.useRef(null);
    var onClick = react_1.useCallback(function () {
        if (onChange) {
            onChange(!value);
        }
    }, [onChange, value]);
    var handleInputChange = react_1.useCallback(function (e) {
        if (!disabled) {
            if (onChange) {
                onChange(e.target.checked);
            }
        }
    }, [disabled, onChange]);
    react_1.useEffect(function () {
        var checkboxRef = inputRef || ref;
        if (checkboxRef.current) {
            checkboxRef.current.indeterminate = Boolean(indeterminate);
        }
    }, [indeterminate, inputRef]);
    return (React.createElement(StyledSimpleCheckboxWrapper, { className: className, ref: innerRef, theme: theme },
        React.createElement(Clickable_1.Clickable, { onClick: disabled ? undefined : onClick },
            React.createElement(InvisibleInput, { disabled: disabled, checked: value, ref: inputRef || ref, onChange: handleInputChange, type: 'checkbox' }),
            React.createElement(Wrapper, { disabled: disabled, theme: theme, indeterminate: indeterminate, value: value },
                React.createElement(Row_1.Row, { justifyContent: 'center', alignItems: 'center', width: theme.width, height: theme.height }, (value || indeterminate) && (React.createElement(Icon_1.Icon, { name: indeterminate ? faMinus_1.faMinus : theme.checkIcon, color: resolveColor({
                        disabled: disabled,
                        indeterminate: indeterminate,
                        theme: theme,
                        value: value,
                    }, 'iconColor'), size: theme.iconSize })))))));
};
exports.SimpleCheckbox = recompose_1.compose(recompose_1.setDisplayName('SimpleCheckbox'), WithComponentTheme_1.withComponentTheme('SimpleCheckbox'))(exports.SimpleCheckboxComponent);
var templateObject_1, templateObject_2, templateObject_3;
//# sourceMappingURL=SimpleCheckbox.js.map