import * as React from 'react';
export interface DateInputProps {
    /** The current value */
    value?: Date;
    /** onChange handler for when the user selects a date. */
    onChange?: (date: Date | undefined) => void;
    /** If true, calendar will be open when component mounts. */
    openOnMount?: boolean;
    /** Is invoked when user closes the calendar popup. */
    onClose?: () => void;
    /**
     * The date format in the input field. See date-fns docs.
     * @default YYYY-MM-dd
     */
    displayFormat?: string;
    /**
     * Placeholder when no date has been selected.
     * @default Enter date
     */
    placeholder?: string;
    /**
     * Z-index of the calendar overlay.
     * @default 100
     */
    zIndex?: number;
}
export interface DateInputPropsWithDefaultProps {
    displayFormat: string;
    placeholder: string;
}
export declare const DateInput: React.ComponentClass<DateInputProps, any>;
