"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var date_fns_1 = require("date-fns");
var React = require("react");
var recompose_1 = require("recompose");
var DateFormats_1 = require("../../../../util/date/DateFormats");
var enhancers_1 = require("../../../util/enhancers");
var colors_1 = require("../../colors");
var decorations_1 = require("../../decorations");
var Indent_1 = require("../../layout/Indent");
var overlay_1 = require("../../overlay");
var positioning_1 = require("../../positioning");
var SingleDateCalendar_1 = require("../calendar/SingleDateCalendar");
var text_input_1 = require("../text-input");
// tslint:disable:no-empty
var noop = function () { };
var SingleDateCalendar = SingleDateCalendar_1.createSingleDateCalendar();
var DateInputComponent = function (_a) {
    var showCalendar = _a.showCalendar, hideCalendar = _a.hideCalendar, displayFormat = _a.displayFormat, showingCalendar = _a.showingCalendar, placeholder = _a.placeholder, onSelectDate = _a.onSelectDate, value = _a.value, zIndex = _a.zIndex, theme = _a.theme, openOnMount = _a.openOnMount;
    return (React.createElement(React.Fragment, null,
        React.createElement(text_input_1.DefaultTextInput, { iconLeft: 'calendar-alt', onFocus: showCalendar, value: value ? date_fns_1.format(value, displayFormat) : '', placeholder: placeholder, onChange: noop, size: 9, forceFocusHighlight: showingCalendar, focusOnMount: openOnMount }),
        showingCalendar && (React.createElement(positioning_1.Relative, null,
            React.createElement(overlay_1.Overlay, { onClickOutside: hideCalendar, backgroundOpacity: 0 }),
            React.createElement(positioning_1.Absolute, { zIndex: zIndex },
                React.createElement(decorations_1.Border, { color: theme.components.DateInput.borderColor },
                    React.createElement(colors_1.Background, { color: theme.components.DateInput.backgroundColor },
                        React.createElement(Indent_1.Indent, null,
                            React.createElement(SingleDateCalendar, { onChange: onSelectDate, value: value, theme: theme.components.DateInput.calendar })))))))));
};
var withShowingCalendarState = recompose_1.withState('showingCalendar', 'setShowingCalendar', function (_a) {
    var openOnMount = _a.openOnMount;
    return openOnMount;
});
var withShowCalendarHandlers = recompose_1.withHandlers({
    showCalendar: function (_a) {
        var setShowingCalendar = _a.setShowingCalendar;
        return function () {
            setShowingCalendar(true);
            return true;
        };
    },
    hideCalendar: function (_a) {
        var setShowingCalendar = _a.setShowingCalendar, onClose = _a.onClose;
        return function () {
            setShowingCalendar(false);
            if (onClose) {
                onClose();
            }
        };
    },
});
var withOnSelectDateHandler = recompose_1.withHandlers({
    onSelectDate: function (_a) {
        var setShowingCalendar = _a.setShowingCalendar, onChange = _a.onChange, hideCalendar = _a.hideCalendar;
        return function (date) {
            if (onChange) {
                onChange(date);
            }
            setTimeout(hideCalendar, 150);
        };
    },
});
var withDefaultProps = recompose_1.defaultProps({
    displayFormat: DateFormats_1.DateFormats.fullDate,
    placeholder: 'Enter date',
    zIndex: 100,
});
exports.DateInput = recompose_1.setDisplayName('DateInput')(recompose_1.compose(withDefaultProps, withShowingCalendarState, withShowCalendarHandlers, withOnSelectDateHandler, enhancers_1.withTheme)(DateInputComponent));
//# sourceMappingURL=DateInput.js.map