import * as React from 'react';
import { DateRangeCalendarOnChangeValue, OnChangePropsDateRangeSelection } from '../calendar/features/DateRangeSelection';
export interface DateRangeInputProps extends OnChangePropsDateRangeSelection {
    /** The current date range value */
    value: DateRangeCalendarOnChangeValue;
    /**
     * The date format in the input field. See date-fns docs.
     * @default YYYY-MM-dd
     */
    displayFormat?: string;
    /**
     * Placeholder for start date field when no date has been selected.
     * @default Start date
     */
    placeholderStartDate?: string;
    /**
     * Placeholder for end date field when no date has been selected.
     * @default End date
     */
    placeholderEndDate?: string;
    /**
     * Z-index of the calendar overlay.
     * @default 100
     */
    zIndex?: number;
    /**
     * Text between the inputs.
     * @default to
     */
    toText?: string;
}
export interface DateRangeInputPropsWithDefaultProps {
    displayFormat: string;
    placeholderStartDate: string;
    placeholderEndDate: string;
}
export declare const DateRangeInput: React.ComponentClass<DateRangeInputProps, any>;
