/// <reference types="react" />
import { Omit } from '../../../../types';
import { SingleDateCalendarProps } from '../calendar';
import { DefaultTextInputProps } from '../text-input';
export declare type DateTextInputCalendarProps<T> = Omit<SingleDateCalendarProps<T>, 'value' | 'onChange' | 'theme'>;
export interface DateTextInputProps<T> extends DefaultTextInputProps {
    /** Props to be passed to Calendar, see SingleDateCalendar for sage */
    calendarProps?: DateTextInputCalendarProps<T>;
    /** Close calendar when date is selected, @default true */
    closeOnCalendarSelectDate?: boolean;
    /** Valid date format, @default YYYY-MM-DD */
    dateFormat?: string;
    /** Make the icon not clickable, @default false */
    disableCalender?: boolean;
    /** Show or hide the calender icon, @default true */
    useCalenderIcon?: boolean;
    /** Onchange callback, returns the current value */
    onChange: (value: string) => void;
    /** Placeholder for the input, @default YYYY-MM-DD */
    placeholder?: string;
    /**  Z-index of the calendar overlay, @default 100 */
    zIndex?: number;
}
export declare const DateTextInput: <T extends {}>({ calendarProps, closeOnCalendarSelectDate, dateFormat, disableCalender, useCalenderIcon, onChange, placeholder, value, width, zIndex, ...props }: DateTextInputProps<T>) => JSX.Element;
