"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var styled_1 = require("@emotion/styled");
var faCalendarAlt_1 = require("@fortawesome/free-regular-svg-icons/faCalendarAlt");
var date_fns_1 = require("date-fns");
var React = require("react");
var react_1 = require("react");
var UseThemeHook_1 = require("../../../theme/UseThemeHook");
var colors_1 = require("../../colors");
var decorations_1 = require("../../decorations");
var icon_1 = require("../../icon");
var interaction_1 = require("../../interaction");
var layout_1 = require("../../layout");
var overlay_1 = require("../../overlay");
var positioning_1 = require("../../positioning");
var calendar_1 = require("../calendar");
var text_input_1 = require("../text-input");
var IconWrapper = styled_1.default(icon_1.Icon)(templateObject_1 || (templateObject_1 = tslib_1.__makeTemplateObject(["\n  color: ", ";\n  &:hover {\n    color: ", ";\n  }\n"], ["\n  color: ", ";\n  &:hover {\n    color: ", ";\n  }\n"])), function (_a) {
    var defaultColor = _a.defaultColor;
    return defaultColor;
}, function (_a) {
    var hoverColor = _a.hoverColor;
    return hoverColor;
});
exports.DateTextInput = function (_a) {
    var calendarProps = _a.calendarProps, _b = _a.closeOnCalendarSelectDate, closeOnCalendarSelectDate = _b === void 0 ? true : _b, _c = _a.dateFormat, dateFormat = _c === void 0 ? 'yyyy-MM-dd' : _c, _d = _a.disableCalender, disableCalender = _d === void 0 ? false : _d, _e = _a.useCalenderIcon, useCalenderIcon = _e === void 0 ? true : _e, onChange = _a.onChange, _f = _a.placeholder, placeholder = _f === void 0 ? 'YYYY-MM-DD' : _f, value = _a.value, _g = _a.width, width = _g === void 0 ? '125px' : _g, _h = _a.zIndex, zIndex = _h === void 0 ? 100 : _h, props = tslib_1.__rest(_a, ["calendarProps", "closeOnCalendarSelectDate", "dateFormat", "disableCalender", "useCalenderIcon", "onChange", "placeholder", "value", "width", "zIndex"]);
    var _j = react_1.useState(false), open = _j[0], setOpen = _j[1];
    var theme = UseThemeHook_1.useTheme();
    var toggleCalendar = function () {
        setOpen(!open);
    };
    var updateValue = function (date) {
        onChange(date);
    };
    var calendar = disableCalender || props.disabled ? (React.createElement(icon_1.Icon, { name: faCalendarAlt_1.faCalendarAlt })) : (useCalenderIcon && (React.createElement(interaction_1.Clickable, { onClick: toggleCalendar },
        React.createElement(IconWrapper, { name: faCalendarAlt_1.faCalendarAlt, hoverColor: theme.components.DateInput.iconHighlightedColor, defaultColor: theme.components.DateInput.iconColor }))));
    var onCalendarSelectDate = function (date) {
        if (date) {
            updateValue(date_fns_1.format(date, dateFormat));
            if (closeOnCalendarSelectDate) {
                setTimeout(function () { return setOpen(!open); }, 200);
            }
        }
    };
    var validInput = value && !/^[-/\\.0-9]+$/.test(value);
    var dateIsValid = value && date_fns_1.isValid(date_fns_1.parse(value, dateFormat, new Date()));
    var userInputCorrectLength = value && value.length >= dateFormat.length;
    return (React.createElement(React.Fragment, null,
        React.createElement(text_input_1.DefaultTextInput, tslib_1.__assign({}, props, { backgroundColor: (userInputCorrectLength && !dateIsValid) || validInput
                ? theme.colors.errorBgLight
                : undefined, contentLeft: calendar, onChange: updateValue, placeholder: placeholder, value: value, width: width })),
        open && (React.createElement(positioning_1.Relative, null,
            React.createElement(overlay_1.Overlay, { onClickOutside: toggleCalendar, backgroundOpacity: 0 }),
            React.createElement(positioning_1.Absolute, { zIndex: zIndex },
                React.createElement(decorations_1.Border, { color: theme.components.DateInput.borderColor },
                    React.createElement(colors_1.Background, { color: theme.components.DateInput.backgroundColor },
                        React.createElement(layout_1.Indent, null,
                            React.createElement(calendar_1.SingleDateCalendar, tslib_1.__assign({}, calendarProps, { onChange: onCalendarSelectDate, value: value && dateIsValid
                                    ? date_fns_1.parse(value, dateFormat, new Date())
                                    : undefined, theme: theme.components.DateInput.calendar }))))))))));
};
var templateObject_1;
//# sourceMappingURL=DateTextInput.js.map