"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var faClock_1 = require("@fortawesome/free-regular-svg-icons/faClock");
var React = require("react");
var react_1 = require("react");
var time_1 = require("../../../../util/time");
var UseThemeHook_1 = require("../../../theme/UseThemeHook");
var DefaultTextInput_1 = require("../text-input/DefaultTextInput");
exports.TimeTextInput = function (_a) {
    var onChange = _a.onChange, _b = _a.showPlaceholder, showPlaceholder = _b === void 0 ? true : _b, _c = _a.useIcon, useIcon = _c === void 0 ? true : _c, value = _a.value, _d = _a.width, width = _d === void 0 ? '85px' : _d, props = tslib_1.__rest(_a, ["onChange", "showPlaceholder", "useIcon", "value", "width"]);
    var _e = react_1.useState(function () { return time_1.validUserInput(value); }), valid = _e[0], setValid = _e[1];
    var timeFormat = 'hh:mm';
    var theme = UseThemeHook_1.useTheme();
    var onBlur = react_1.useCallback(function () {
        if (value) {
            var formattedResult = time_1.formatTimeString(value);
            setValid(formattedResult.success);
            if (formattedResult.success) {
                if (onChange) {
                    onChange(formattedResult.time);
                }
            }
        }
    }, [value, onChange, setValid]);
    var updateValue = react_1.useCallback(function (time) {
        var validInput = time_1.validUserInput(time);
        setValid(validInput && time.length <= timeFormat.length);
        if (onChange) {
            onChange(time);
        }
    }, [onChange, setValid]);
    return (React.createElement(DefaultTextInput_1.DefaultTextInput, tslib_1.__assign({}, props, { backgroundColor: valid ? undefined : theme.colors.errorBgLight, iconLeft: useIcon ? faClock_1.faClock : undefined, value: value, placeholder: showPlaceholder ? timeFormat : undefined, onChange: updateValue, onBlur: onBlur, width: width })));
};
//# sourceMappingURL=TimeTextInput.js.map