"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
exports.MultipleOption = function (_a) {
    var allLabel = _a.allLabel, onAllClick = _a.onAllClick, onOptionClick = _a.onOptionClick, options = _a.options;
    var allChecked = options.every(function (option) { return option.checked; });
    var onOptionAllClicked = function (e) {
        onAllClick(e, allChecked);
    };
    return (React.createElement("div", null,
        React.createElement("label", null,
            React.createElement("input", { name: "all", type: "checkbox", checked: allChecked, onChange: onOptionAllClicked }),
            React.createElement("span", null, allLabel)),
        options.map(function (option, index) {
            var onClick = function (e) {
                return onOptionClick(e, option);
            };
            return (React.createElement("div", { className: "options", key: index },
                React.createElement("label", null,
                    React.createElement("input", { type: "checkbox", checked: option.checked, onChange: onClick }),
                    React.createElement("span", null, option.label))));
        })));
};
//# sourceMappingURL=MultipleOption.js.map