"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var recompose_1 = require("recompose");
var enhancers_1 = require("../../../util/enhancers");
var withOnToggleHandler_1 = require("../../../util/enhancers/withOnToggleHandler");
var Icon_1 = require("../../icon/Icon");
var Clickable_1 = require("../../interaction/Clickable");
var Row_1 = require("../../layout/Row");
exports.RadioButtonComponent = function (_a) {
    var disabled = _a.disabled, onChange = _a.onChange, onToggle = _a.onToggle, theme = _a.theme, value = _a.value;
    var iconColor = theme.iconColor;
    if (disabled) {
        iconColor = theme.disabledIconColor;
    }
    else if (!value) {
        iconColor = theme.notCheckedColor;
    }
    return (React.createElement(Row_1.Row, null,
        React.createElement(Clickable_1.Clickable, { onClick: disabled ? undefined : onToggle },
            React.createElement(Icon_1.Icon, { color: iconColor, name: value ? theme.checkedIcon : theme.notCheckedIcon, size: theme.iconSize }))));
};
exports.RadioButton = recompose_1.setDisplayName('RadioButton')(recompose_1.compose(recompose_1.pure, withOnToggleHandler_1.withOnToggleHandler, enhancers_1.withComponentTheme('RadioButton'))(exports.RadioButtonComponent));
//# sourceMappingURL=RadioButton.js.map