"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var recompose_1 = require("recompose");
var enhancers_1 = require("../../../util/enhancers");
var withOnToggleHandler_1 = require("../../../util/enhancers/withOnToggleHandler");
var Clickable_1 = require("../../interaction/Clickable");
var Row_1 = require("../../layout/Row");
var Space_1 = require("../../layout/Space");
var DefaultText_1 = require("../../text/DefaultText");
var RadioButton_1 = require("./RadioButton");
exports.RadioButtonWithLabelComponent = function (_a) {
    var disabled = _a.disabled, label = _a.label, onToggle = _a.onToggle, theme = _a.theme, value = _a.value;
    return (React.createElement(Clickable_1.Clickable, { onClick: disabled ? undefined : onToggle },
        React.createElement(Row_1.Row, null,
            React.createElement(RadioButton_1.RadioButton, tslib_1.__assign({}, { theme: theme }, { value: value })),
            React.createElement(Space_1.Space, null),
            React.createElement(DefaultText_1.DefaultText, { color: disabled ? theme.disabledTextColor : theme.textColor, theme: { fontSize: theme.textSize } }, label))));
};
exports.RadioButtonWithLabel = recompose_1.setDisplayName('RadioButtonWithLabel')(recompose_1.compose(withOnToggleHandler_1.withOnToggleHandler, enhancers_1.withComponentTheme('RadioButton'))(exports.RadioButtonWithLabelComponent));
//# sourceMappingURL=RadioButtonWithLabel.js.map