"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var styled_1 = require("@emotion/styled");
var faCheck_1 = require("@fortawesome/free-solid-svg-icons/faCheck");
var React = require("react");
var react_1 = require("react");
var recompose_1 = require("recompose");
var enhancers_1 = require("../../../util/enhancers");
var icon_1 = require("../../icon");
var InvisibleInput = styled_1.default.input(templateObject_1 || (templateObject_1 = tslib_1.__makeTemplateObject(["\n  top: 0;\n  left: 0;\n  width: 100%;\n  cursor: inherit;\n  height: 100%;\n  margin: 0;\n  opacity: 0;\n  padding: 0;\n  position: absolute;\n"], ["\n  top: 0;\n  left: 0;\n  width: 100%;\n  cursor: inherit;\n  height: 100%;\n  margin: 0;\n  opacity: 0;\n  padding: 0;\n  position: absolute;\n"])));
var Back = styled_1.default('div')(templateObject_2 || (templateObject_2 = tslib_1.__makeTemplateObject(["\n  cursor: ", ";\n  width: ", "px;\n  height: ", "px;\n  border-radius: ", "px;\n  background-color: ", ";\n  position: relative;\n\n  :hover {\n    opacity: ", ";\n  }\n"], ["\n  cursor: ", ";\n  width: ", "px;\n  height: ", "px;\n  border-radius: ", "px;\n  background-color: ",
    ";\n  position: relative;\n\n  :hover {\n    opacity: ", ";\n  }\n"])), function (_a) {
    var disabled = _a.disabled;
    return (disabled ? 'inherit' : 'pointer');
}, function (_a) {
    var theme = _a.theme;
    return theme.width;
}, function (_a) {
    var theme = _a.theme;
    return theme.height;
}, function (_a) {
    var theme = _a.theme;
    return theme.borderRadius;
}, function (_a) {
    var value = _a.value, disabled = _a.disabled, theme = _a.theme;
    return disabled
        ? theme.disabledColors.backgroundColor
        : value
            ? theme.checkedColors.backgroundColor
            : theme.colors.backgroundColor;
}, function (_a) {
    var disabled = _a.disabled;
    return (disabled ? '1' : '0.7');
});
var Front = styled_1.default('div')(templateObject_3 || (templateObject_3 = tslib_1.__makeTemplateObject(["\n  background-color: ", ";\n  border-radius: ", "px;\n  height: ", "px;\n  position: absolute;\n  right ", "px;\n  top: 2px;\n  transition: right 0.1s linear;\n  width: ", "px; \n"], ["\n  background-color: ",
    ";\n  border-radius: ", "px;\n  height: ", "px;\n  position: absolute;\n  right ",
    "px;\n  top: 2px;\n  transition: right 0.1s linear;\n  width: ", "px; \n"])), function (_a) {
    var value = _a.value, disabled = _a.disabled, theme = _a.theme;
    return disabled
        ? theme.disabledColors.iconBackgroundColor
        : value
            ? theme.checkedColors.iconBackgroundColor
            : theme.colors.iconBackgroundColor;
}, function (_a) {
    var theme = _a.theme;
    return theme.borderRadius - 1;
}, function (_a) {
    var theme = _a.theme;
    return theme.height - 4;
}, function (_a) {
    var value = _a.value, theme = _a.theme;
    return value ? 2 : "" + (theme.width - theme.height + 2);
}, function (_a) {
    var theme = _a.theme;
    return theme.height - 4;
});
var IconWrapper = styled_1.default('div')(templateObject_4 || (templateObject_4 = tslib_1.__makeTemplateObject(["\n  align-items: center;\n  display: flex;\n  height: ", "px;\n  justify-content: center;\n  width: ", "px;\n  opacity: ", ";\n  transition: opacity 0.1s linear;\n"], ["\n  align-items: center;\n  display: flex;\n  height: ", "px;\n  justify-content: center;\n  width: ", "px;\n  opacity: ", ";\n  transition: opacity 0.1s linear;\n"])), function (_a) {
    var theme = _a.theme;
    return theme.height - 4;
}, function (_a) {
    var theme = _a.theme;
    return theme.height - 4;
}, function (_a) {
    var value = _a.value;
    return (value ? 1 : 0);
});
var SwitchComponent = function (_a) {
    var className = _a.className, _b = _a.disabled, disabled = _b === void 0 ? false : _b, inputRef = _a.inputRef, onChange = _a.onChange, value = _a.value, innerRef = _a.innerRef, theme = _a.theme, rest = tslib_1.__rest(_a, ["className", "disabled", "inputRef", "onChange", "value", "innerRef", "theme"]);
    var handleInputChange = react_1.useCallback(function (e) {
        if (!disabled) {
            onChange(e.target.checked);
        }
    }, [disabled, onChange]);
    var handleSwitchClick = react_1.useCallback(function () {
        if (!disabled) {
            onChange(!value);
        }
    }, [disabled, onChange, value]);
    return (React.createElement("div", { ref: innerRef },
        React.createElement(Back, { value: value, className: className, disabled: disabled, onClick: handleSwitchClick, theme: theme },
            React.createElement(InvisibleInput, { checked: value, onChange: handleInputChange, ref: inputRef, type: 'checkbox' }),
            React.createElement(Front, { value: value, disabled: disabled, theme: theme },
                React.createElement(IconWrapper, { theme: theme, value: value },
                    React.createElement(icon_1.Icon, { color: disabled
                            ? theme.disabledColors.iconColor
                            : value
                                ? theme.checkedColors.iconColor
                                : theme.colors.iconColor, name: faCheck_1.faCheck, size: theme.height - 8 }))))));
};
exports.Switch = recompose_1.compose(recompose_1.setDisplayName('Switch'), enhancers_1.withComponentTheme('Switch'))(SwitchComponent);
var templateObject_1, templateObject_2, templateObject_3, templateObject_4;
//# sourceMappingURL=Switch.js.map