"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var SimpleTextInput_1 = require("./SimpleTextInput");
var Debounce_1 = require("../../../util/events/Debounce");
var DebouncedTextInput = /** @class */ (function (_super) {
    tslib_1.__extends(DebouncedTextInput, _super);
    function DebouncedTextInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onChange = function (value) {
            var onChange = _this.props.onChange;
            if (onChange) {
                onChange(value);
            }
        };
        _this.debouncedOnChange = function (value) {
            var debouncedOnChange = _this.props.debouncedOnChange;
            if (debouncedOnChange) {
                debouncedOnChange(value);
            }
        };
        return _this;
    }
    DebouncedTextInput.prototype.render = function () {
        var _this = this;
        var _a = this.props, value = _a.value, simpleTextInputProps = tslib_1.__rest(_a, ["value"]);
        return (React.createElement(Debounce_1.Debounce, { func: this.debouncedOnChange }, function (dbOnChange) { return (React.createElement(SimpleTextInput_1.SimpleTextInput, tslib_1.__assign({}, simpleTextInputProps, { value: value, onChange: function (v) {
                _this.onChange(v);
                dbOnChange(v);
            } }))); }));
    };
    return DebouncedTextInput;
}(React.Component));
exports.DebouncedTextInput = DebouncedTextInput;
//# sourceMappingURL=DebouncedTextInput.js.map