import { IconProp } from '@fortawesome/fontawesome-svg-core';
import * as React from 'react';
import { ComponentThemeProps } from '../../../util/enhancers';
import { SimpleTextInputProps } from './SimpleTextInput';
export declare type __C_DEFAULT_TEXT_INPUT_12491142 = React.ComponentClass<{}>;
export interface DefaultTextInputProps extends SimpleTextInputProps, ComponentThemeProps<'DefaultTextInput'> {
    /** React node to put to the left. Left icon is ignored if this is set. */
    contentLeft?: React.ReactNode;
    /** React node to put to the right. Right icon is ignored if this is set. */
    contentRight?: React.ReactNode;
    /** If true, there will be no padding between contentLeft/contentRight and the border. */
    disableContentPadding?: boolean;
    /** If true, there will be no padding between contentLeft and the border. */
    disableContentPaddingLeft?: boolean;
    /** If true, there will be no padding between contentRight and the border. */
    disableContentPaddingRight?: boolean;
    /** Icon on the left side. */
    iconLeft?: IconProp;
    /** Icon on the right side. */
    iconRight?: IconProp;
    /** Color of the icon on the left side. */
    iconColorLeft?: string;
    /** Color of the icon on the right side. */
    iconColorRight?: string;
    /** Size of the icon on the left side. */
    iconSizeLeft?: number;
    /** Size of the icon on the right side. */
    iconSizeRight?: number;
    /** Force focus highlight. */
    forceFocusHighlight?: boolean;
}
export declare const DefaultTextInput: React.ComponentClass<DefaultTextInputProps, any>;
