"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var styled_1 = require("@emotion/styled");
var React = require("react");
var recompose_1 = require("recompose");
var enhancers_1 = require("../../../util/enhancers");
var colors_1 = require("../../colors");
var decorations_1 = require("../../decorations");
var icon_1 = require("../../icon");
var layout_1 = require("../../layout");
var SimpleTextInput_1 = require("./SimpleTextInput");
// TODO Move to theme.
var StyledBorder = styled_1.default(decorations_1.Border)(templateObject_1 || (templateObject_1 = tslib_1.__makeTemplateObject(["\n  display: inline-block;\n  overflow: hidden;\n"], ["\n  display: inline-block;\n  overflow: hidden;\n"])));
var StyledSimpleTextInput = styled_1.default(SimpleTextInput_1.SimpleTextInput)(templateObject_2 || (templateObject_2 = tslib_1.__makeTemplateObject(["\n  border: 0;\n  :focus {\n    outline: 0;\n  }\n"], ["\n  border: 0;\n  :focus {\n    outline: 0;\n  }\n"])));
var TextInputIcon = function (_a) {
    var icon = _a.icon, content = _a.content, iconColor = _a.iconColor, iconSize = _a.iconSize, theme = _a.theme, spaceOnLeft = _a.spaceOnLeft, spaceOnRight = _a.spaceOnRight, disableContentPadding = _a.disableContentPadding, disableContentPaddingLeft = _a.disableContentPaddingLeft, disableContentPaddingRight = _a.disableContentPaddingRight;
    if (!content && !icon) {
        return null;
    }
    if (content) {
        return (React.createElement(React.Fragment, null,
            spaceOnLeft &&
                !(disableContentPadding || disableContentPaddingLeft) && React.createElement(layout_1.Space, null),
            content,
            spaceOnRight &&
                !(disableContentPadding || disableContentPaddingRight) && React.createElement(layout_1.Space, null)));
    }
    return (React.createElement(React.Fragment, null,
        spaceOnLeft && React.createElement(layout_1.Space, null),
        icon && (React.createElement(icon_1.Icon, { name: icon, size: iconSize || theme.iconSize, color: iconColor })),
        spaceOnRight && React.createElement(layout_1.Space, null)));
};
var DefaultTextInputComponent = function (_a) {
    var textColor = _a.textColor, focused = _a.focused, contentLeft = _a.contentLeft, contentRight = _a.contentRight, iconLeft = _a.iconLeft, iconRight = _a.iconRight, iconColorLeft = _a.iconColorLeft, iconColorRight = _a.iconColorRight, iconSizeLeft = _a.iconSizeLeft, iconSizeRight = _a.iconSizeRight, backgroundColor = _a.backgroundColor, forceFocusHighlight = _a.forceFocusHighlight, _b = _a.disableContentPadding, disableContentPadding = _b === void 0 ? false : _b, _c = _a.disableContentPaddingLeft, disableContentPaddingLeft = _c === void 0 ? false : _c, _d = _a.disableContentPaddingRight, disableContentPaddingRight = _d === void 0 ? false : _d, theme = _a.theme, disabled = _a.disabled, inputProps = tslib_1.__rest(_a, ["textColor", "focused", "contentLeft", "contentRight", "iconLeft", "iconRight", "iconColorLeft", "iconColorRight", "iconSizeLeft", "iconSizeRight", "backgroundColor", "forceFocusHighlight", "disableContentPadding", "disableContentPaddingLeft", "disableContentPaddingRight", "theme", "disabled"]);
    return (React.createElement(StyledBorder, { borderRadius: theme.borderRadius, color: forceFocusHighlight || focused
            ? theme.borderColorFocused
            : theme.borderColor, borderStyle: theme.borderStyle, width: theme.borderWidth, style: { width: inputProps.width || '100%' } },
        React.createElement(colors_1.Background, { color: disabled
                ? theme.disabledBackgroundColor
                : backgroundColor || theme.backgroundColor, style: { width: inputProps.width || '100%' } },
            React.createElement(layout_1.Row, { alignItems: 'center', style: { width: inputProps.width || '100%' } },
                React.createElement(TextInputIcon, { content: contentLeft, disableContentPadding: disableContentPadding, disableContentPaddingLeft: disableContentPaddingLeft, disableContentPaddingRight: disableContentPaddingRight, icon: iconLeft, iconColor: iconColorLeft, iconSize: iconSizeLeft, spaceOnLeft: true, theme: theme }),
                React.createElement("div", { style: { width: '100%' } },
                    React.createElement(StyledSimpleTextInput, tslib_1.__assign({}, inputProps, { backgroundColor: backgroundColor || theme.backgroundColor, disabled: disabled, fontSize: theme.fontSize, height: theme.height, style: tslib_1.__assign({ paddingLeft: theme.paddingLeft, paddingRight: theme.paddingRight, boxSizing: 'border-box' }, inputProps.style), textColor: textColor || theme.textColor, width: '100%' }))),
                React.createElement(TextInputIcon, { content: contentRight, disableContentPadding: disableContentPadding, disableContentPaddingLeft: disableContentPaddingLeft, disableContentPaddingRight: disableContentPaddingRight, icon: iconRight, iconColor: iconColorRight, iconSize: iconSizeRight, spaceOnRight: true, theme: theme })))));
};
var withFocusState = recompose_1.withStateHandlers({ focused: false }, {
    onBlur: function (_a, _b) {
        var onBlur = _b.onBlur;
        return function () {
            if (onBlur) {
                onBlur();
            }
            return {
                focused: false,
            };
        };
    },
    onFocus: function (_a, _b) {
        var onFocus = _b.onFocus;
        return function () {
            if (onFocus) {
                onFocus();
            }
            return {
                focused: true,
            };
        };
    },
});
exports.DefaultTextInput = recompose_1.setDisplayName('DefaultTextInput')(recompose_1.compose(enhancers_1.withComponentTheme('DefaultTextInput'), withFocusState, withFocusState)(DefaultTextInputComponent));
var templateObject_1, templateObject_2;
//# sourceMappingURL=DefaultTextInput.js.map