"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var React = require("react");
var recompose_1 = require("recompose");
var enhancers_1 = require("../../util/enhancers");
var text_1 = require("../text");
var IconComponent = function (_a) {
    var className = _a.className, color = _a.color, flip = _a.flip, name = _a.name, pulse = _a.pulse, rotation = _a.rotation, _b = _a.size, size = _b === void 0 ? 20 : _b, _c = _a.source, source = _c === void 0 ? 'fontawesome' : _c, spin = _a.spin, style = _a.style, transform = _a.transform;
    if (source === 'fontawesome') {
        return (React.createElement(react_fontawesome_1.FontAwesomeIcon, { className: className, color: color, flip: flip, icon: name, pulse: pulse, rotation: rotation, spin: spin, style: tslib_1.__assign({ fontSize: size }, style), transform: transform }));
    }
    return React.createElement(text_1.DefaultText, null,
        "Invalid icon source '",
        source,
        "'");
};
var withDefaultColor = recompose_1.withProps(function (_a) {
    var theme = _a.theme, color = _a.color;
    return ({
        color: color || theme.colors.primaryTextLight,
    });
});
exports.Icon = recompose_1.setDisplayName('Icon')(recompose_1.compose(enhancers_1.withTheme, withDefaultColor)(IconComponent));
//# sourceMappingURL=Icon.js.map