import * as React from 'react';
export interface ClickableProps {
    /** Callback function called when clicking on click area. */
    onClick?: React.MouseEventHandler<HTMLDivElement>;
    /** Callback function called when double clicking on click area. */
    onDblClick?: React.MouseEventHandler<HTMLDivElement>;
    /** Adds a title to the click area. */
    tooltip?: string;
    /** If set, there is no opacity applies when clicking on the click area. */
    disableOpacityOnClick?: boolean;
    /** Mouse does not turn into pointer when hovering over click area. */
    disablePointer?: boolean;
    /** When set, click area receives opacity when mouse hovers over it. */
    opacityOnHover?: boolean;
    /** Custom style on div with click event. */
    style?: React.CSSProperties;
}
export interface MouseIsDown {
    mouseIsDown: boolean;
}
export interface SetMouseIsDown {
    setMouseIsDown: (mouseIsDown: boolean) => void;
}
export interface ClickHandlers {
    onMouseDown: () => void;
    onMouseUp: () => void;
    onMouseOut: () => void;
}
export declare type ClickableInnerProps = ClickableProps & MouseIsDown & ClickHandlers;
export declare class ClickableComponent extends React.Component<ClickableInnerProps> {
    render(): JSX.Element;
}
export declare const Clickable: React.ComponentClass<ClickableProps, any>;
