"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var styled_1 = require("@emotion/styled");
var React = require("react");
var recompose_1 = require("recompose");
var HoverStyledDiv = styled_1.default.div(templateObject_1 || (templateObject_1 = tslib_1.__makeTemplateObject(["\n  :hover {\n    ", ";\n  }\n"], ["\n  :hover {\n    ", ";\n  }\n"])), function (props) { return (props.opacityOnHover ? 'opacity: 0.7;' : ''); });
HoverStyledDiv.displayName = 'HoverStyledDiv';
var ClickableComponent = /** @class */ (function (_super) {
    tslib_1.__extends(ClickableComponent, _super);
    function ClickableComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ClickableComponent.prototype.render = function () {
        var _a = this.props, onClick = _a.onClick, onDblClick = _a.onDblClick, tooltip = _a.tooltip, disableOpacityOnClick = _a.disableOpacityOnClick, disablePointer = _a.disablePointer, opacityOnHover = _a.opacityOnHover, style = _a.style, onMouseDown = _a.onMouseDown, onMouseUp = _a.onMouseUp, mouseIsDown = _a.mouseIsDown, onMouseOut = _a.onMouseOut;
        var hasClickHandler = !!(onClick || onDblClick);
        var opacity = !disableOpacityOnClick && mouseIsDown ? 0.5 : undefined;
        return (React.createElement(HoverStyledDiv, { opacityOnHover: opacityOnHover, title: tooltip, style: tslib_1.__assign({ cursor: hasClickHandler && !disablePointer ? 'pointer' : undefined, display: 'inline-block', userSelect: 'none', opacity: opacity }, style), onClick: onClick, onDoubleClick: onDblClick, onMouseDown: getMouseCallback(hasClickHandler, onMouseDown), onMouseUp: getMouseCallback(hasClickHandler, onMouseUp), onMouseOut: getMouseCallback(hasClickHandler, onMouseOut) }, this.props.children));
    };
    return ClickableComponent;
}(React.Component));
exports.ClickableComponent = ClickableComponent;
exports.Clickable = recompose_1.setDisplayName('Clickable')(recompose_1.compose(recompose_1.withState('mouseIsDown', 'setMouseIsDown', false), recompose_1.withHandlers({
    onMouseDown: function (_a) {
        var setMouseIsDown = _a.setMouseIsDown;
        return function () {
            setMouseIsDown(true);
        };
    },
    onMouseUp: function (_a) {
        var setMouseIsDown = _a.setMouseIsDown;
        return function () {
            setMouseIsDown(false);
        };
    },
    onMouseOut: function (_a) {
        var setMouseIsDown = _a.setMouseIsDown;
        return function () {
            setMouseIsDown(false);
        };
    },
}))(ClickableComponent));
var getMouseCallback = function (clickable, callback) {
    if (clickable) {
        return callback;
    }
    return undefined;
};
var templateObject_1;
//# sourceMappingURL=Clickable.js.map