"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var KeyListener = /** @class */ (function (_super) {
    tslib_1.__extends(KeyListener, _super);
    function KeyListener() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onKeyDown = function (e) {
            var _a = _this.props, keyCode = _a.keyCode, onKey = _a.onKey, disablePreventDefault = _a.disablePreventDefault, disableStopPropagation = _a.disableStopPropagation;
            if (e.keyCode === keyCode && onKey) {
                if (!disablePreventDefault) {
                    e.preventDefault();
                }
                if (!disableStopPropagation) {
                    e.stopPropagation();
                }
                onKey();
            }
        };
        return _this;
    }
    KeyListener.prototype.render = function () {
        return React.createElement("div", { onKeyDown: this.onKeyDown }, this.props.children);
    };
    return KeyListener;
}(React.Component));
exports.KeyListener = KeyListener;
//# sourceMappingURL=KeyListener.js.map