"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var recompose_1 = require("recompose");
var layout_1 = require("../layout");
var getDirection = function (position) {
    if (position === 'top-left' || position === 'top-right') {
        return 'column';
    }
    return 'row';
};
var getAligning = function (position) {
    if (position === 'left-top' || position === 'top-left') {
        return 'flex-start';
    }
    else if (position === 'left-bottom' || position === 'top-right') {
        return 'flex-end';
    }
    return 'flex-start';
};
exports.Label = recompose_1.setDisplayName('Label')(function (_a) {
    var children = _a.children, label = _a.label, num = _a.num, _b = _a.position, position = _b === void 0 ? 'top-left' : _b;
    return (React.createElement("div", { style: {
            display: 'inline-flex',
            flexDirection: getDirection(position),
        } },
        React.createElement("div", { style: { alignSelf: getAligning(position) } }, label),
        React.createElement(layout_1.Space, { num: num }),
        React.createElement("div", null, children)));
});
//# sourceMappingURL=Label.js.map