import * as React from 'react';
import { AlignItemsProps, BackgroundProps, DisplayProps, FlexDirectionProps, FlexProps, FlexWrapProps, HeightProps, JustifyContentProps, MaxHeightProps, MaxWidthProps, MinHeightProps, MinWidthProps, WidthProps } from 'styled-system';
import { Omit } from '../../../types/Omit';
declare type StyledSystemProps = AlignItemsProps & DisplayProps & BackgroundProps & FlexDirectionProps & FlexProps & FlexWrapProps & HeightProps & JustifyContentProps & MinHeightProps & MaxHeightProps & MinWidthProps & MaxWidthProps & WidthProps;
export interface BoxProps extends StyledSystemProps {
    innerRef?: React.Ref<HTMLDivElement>;
    row?: boolean;
    spacing?: boolean | number;
    indent?: boolean | number;
    style?: React.CSSProperties;
}
export declare const Box: React.FC<BoxProps>;
export declare type RowBoxProps = Omit<BoxProps, 'row'>;
export declare const RowBox: React.FC<RowBoxProps>;
export declare type ColumnBoxProps = Omit<BoxProps, 'row'>;
export declare const ColumnBox: React.FC<ColumnBoxProps>;
export {};
