"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var recompose_1 = require("recompose");
var StandardButton_1 = require("../buttons/StandardButton");
var Overlay_1 = require("./Overlay");
var Clickable_1 = require("../interaction/Clickable");
var OverlayToggleButtonComponent = /** @class */ (function (_super) {
    tslib_1.__extends(OverlayToggleButtonComponent, _super);
    function OverlayToggleButtonComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    OverlayToggleButtonComponent.prototype.renderChildren = function () {
        var _a = this.props, children = _a.children, close = _a.close;
        if (typeof children === 'function') {
            return children({ close: close });
        }
        return children;
    };
    OverlayToggleButtonComponent.prototype.render = function () {
        var _a = this.props, renderButton = _a.renderButton, open = _a.open, onClick = _a.onClick, close = _a.close, detachOverlay = _a.detachOverlay, backgroundOpacity = _a.backgroundOpacity;
        return (React.createElement(React.Fragment, null,
            renderButton ? (React.createElement(Clickable_1.Clickable, { onClick: onClick }, renderButton)) : (React.createElement(StandardButton_1.StandardButton, tslib_1.__assign({ onClick: onClick }, this.props))),
            open &&
                !detachOverlay && (React.createElement(Overlay_1.Overlay, { backgroundOpacity: backgroundOpacity, onClickOutside: close }, this.renderChildren())),
            open &&
                detachOverlay && (React.createElement(React.Fragment, null,
                React.createElement(Overlay_1.Overlay, { backgroundOpacity: backgroundOpacity, onClickOutside: close }),
                this.renderChildren()))));
    };
    return OverlayToggleButtonComponent;
}(React.Component));
var openState = recompose_1.withState('open', 'setOpen', false);
var clickHandlers = recompose_1.withHandlers({
    onClick: function (_a) {
        var setOpen = _a.setOpen, open = _a.open;
        return function () {
            setOpen(!open);
        };
    },
    close: function (_a) {
        var setOpen = _a.setOpen;
        return function () {
            setOpen(false);
        };
    },
});
exports.OverlayToggleButton = recompose_1.compose(openState, clickHandlers)(OverlayToggleButtonComponent);
//# sourceMappingURL=OverlayToggleButton.js.map