"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var styled_1 = require("@emotion/styled");
var React = require("react");
var enhanceWithClickOutside = require("react-click-outside");
exports.POPUP_BOX_SHADOW = 'rgba(0, 0, 0, 0.28) 0 2px 13px 0';
var TargetContainer = styled_1.default('div')(function (props) { return ({
    backgroundColor: props.backgroundColor || '#fff',
    boxShadow: props.shadow ? exports.POPUP_BOX_SHADOW : undefined,
    minHeight: props.targetMinHeight,
    minWidth: props.targetMinWidth,
}); });
var PurePopper = /** @class */ (function (_super) {
    tslib_1.__extends(PurePopper, _super);
    function PurePopper() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.renderPropsChildren = function (_a) {
            var ref = _a.ref, popperChildrenStyle = _a.style, placement = _a.placement, arrowProps = _a.arrowProps;
            var _b = _this.props, backgroundColor = _b.backgroundColor, children = _b.children, _c = _b.shadow, shadow = _c === void 0 ? true : _c, style = _b.style, targetMinHeight = _b.targetMinHeight, targetMinWidth = _b.targetMinWidth;
            return (React.createElement("div", { ref: ref, style: tslib_1.__assign({}, popperChildrenStyle, style), "data-placement": placement },
                React.createElement(TargetContainer, { backgroundColor: backgroundColor, shadow: shadow, targetMinHeight: targetMinHeight, targetMinWidth: targetMinWidth }, children),
                React.createElement("div", { ref: arrowProps.ref, style: arrowProps.style })));
        };
        return _this;
    }
    PurePopper.prototype.render = function () {
        var _a = this.props, modifiers = _a.modifiers, PopperComponent = _a.PopperComponent, _b = _a.placement, popupPlacement = _b === void 0 ? 'auto-end' : _b;
        return (React.createElement(PopperComponent, { placement: popupPlacement, modifiers: modifiers }, this.renderPropsChildren));
    };
    PurePopper.prototype.handleClickOutside = function () {
        var onClickOutside = this.props.onClickOutside;
        if (onClickOutside) {
            onClickOutside();
        }
    };
    return PurePopper;
}(React.Component));
exports.PurePopper = PurePopper;
exports.EnhancedPopper = enhanceWithClickOutside(PurePopper);
//# sourceMappingURL=EnhancedPopper.js.map