"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var recompose_1 = require("recompose");
var Popup_1 = require("./Popup");
var withToggleStateHandlers = recompose_1.withStateHandlers(function () { return ({
    open: false,
}); }, {
    hide: function () { return function () {
        return {
            open: false,
        };
    }; },
    show: function () { return function () {
        return {
            open: true,
        };
    }; },
});
var withPopupProps = recompose_1.withProps(function (_a) {
    var children = _a.children, hide = _a.hide, show = _a.show, rest = tslib_1.__rest(_a, ["children", "hide", "show"]);
    return tslib_1.__assign({ children: typeof children === 'function'
            ? children({ onClose: hide })
            : children, onClickOutside: hide, onOpen: show }, rest);
});
exports.UncontrolledPopup = recompose_1.compose(withToggleStateHandlers, withPopupProps)(Popup_1.Popup);
//# sourceMappingURL=UncontrolledPopup.js.map