/// <reference types="react" />
export interface ProgressProps {
    /** Spinner track color */
    trackColor?: string;
    /** Loading background color */
    backgroundColor?: string;
    /** Opacity of icon. */
    opacity?: number;
    /** Size of icon. */
    size?: number;
    /** Size of "pie hole" in the middle. */
    width?: number;
    /** Override spinner props. */
    spinnerProps?: ProgressSpinnerProps;
    /** Overriding style. */
    style?: {};
}
export interface ProgressSpinnerProps {
    /** Spinner background color. */
    backgroundColor?: string;
    /** Speed for 360 degress. */
    duration?: number;
    /** Opacity. */
    opacity?: number;
    /** Size of icon. */
    size: number;
    /** Spinner track color */
    trackColor?: string;
    /** Size of "pie hole" in the middle. */
    width: number;
}
export declare const Progress: ({ backgroundColor, trackColor, opacity, size, width, spinnerProps, style, }: ProgressProps) => JSX.Element;
