import * as React from 'react';
import { ComponentEnhancer } from 'recompose';
import { Marks } from './TimeSlider';
export declare type __C_SLIDER = ComponentEnhancer<{}, {}>;
export interface SliderProps {
    /** Maximum value of the slider */
    max: number;
    /** Minimum value of the slider */
    min: number;
    /** onChange will be triggered while the value of Slider changing */
    onChange: (value: number[]) => void;
    /** Value to be added or subtracted on each step the slider makes, must be greater than zero */
    step?: number;
    /** Set current positions of handles */
    value: number[];
    /** Marks on the slider. The key determines the position, and the value determines what will show */
    marks?: Marks;
}
export declare const createSlider: <TRangeProps extends {}>(rangeComponent: React.ComponentType<TRangeProps>) => React.ComponentClass<SliderProps, any>;
