import * as React from 'react';
export declare type __C_TIME_SLIDER = React.ComponentClass<{}>;
export interface Marks {
    [key: number]: JSX.Element | string | {
        style: {};
        label: string | JSX.Element;
    };
}
export interface Time {
    /** hours */
    hours: number;
    /** minutes */
    minutes: number;
}
export interface TimeSliderProps {
    /** onChange will be triggered while the value of Slider changing */
    onChange: (value: {
        hours: number;
        minutes: number;
    }[]) => void;
    /** In minutes, value to be added or subtracted on each step the slider makes, must be greater than zero */
    step?: number;
    /** Set current positions of handles */
    value: {
        hours: number;
        minutes: number;
    }[];
    /** If true, show marks on slider. Marks defaults to step interval if marksInterval is undefined */
    showMarks?: boolean;
    /** In minutes, show time marks on slider. If undefined, uses step instead.
     * Marks are only shown if showMarks is true
     */
    marksInterval?: number;
}
export declare const createTimeSlider: <TRangeProps extends {}>(rangeComponent: React.ComponentType<TRangeProps>) => React.ComponentClass<TimeSliderProps, any>;
