"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var recompose_1 = require("recompose");
var Slider_1 = require("./Slider");
var sliderUtils_1 = require("./sliderUtils");
var TEN_MINUTES_STEP = 10;
var max = 60 * 24;
var min = 0;
var withOnSliderChange = recompose_1.withHandlers({
    onChange: function (_a) {
        var onSliderChange = _a.onChange;
        return function (sliderValue) {
            onSliderChange(sliderValue.map(function (time) { return sliderUtils_1.getValue(time, max); }));
        };
    },
});
var withSliderProps = recompose_1.withProps(function (_a) {
    var _b = _a.showMarks, showMarks = _b === void 0 ? false : _b, _c = _a.step, step = _c === void 0 ? TEN_MINUTES_STEP : _c, marksInterval = _a.marksInterval, value = _a.value, onChange = _a.onChange;
    return ({
        marks: sliderUtils_1.generateMarks(showMarks, step, max, marksInterval),
        max: max,
        min: min,
        onChange: onChange,
        value: sliderUtils_1.convertTimesToSliderValue(value, max),
        step: step,
    });
});
exports.createTimeSlider = function (rangeComponent) {
    return recompose_1.compose(withOnSliderChange, withSliderProps)(Slider_1.createSlider(rangeComponent));
};
//# sourceMappingURL=TimeSlider.js.map