"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeTwoDigit = function (value) {
    var valueString = value.toString(10);
    if (valueString.length === 1) {
        return "0" + value;
    }
    return valueString;
};
exports.convertToTimeLabel = function (hours, minutes) {
    return exports.makeTwoDigit(hours) + ":" + exports.makeTwoDigit(minutes);
};
exports.getValue = function (value, max) {
    var minutesPerValue = (60 * 24) / max;
    var time = value * minutesPerValue;
    return {
        hours: Math.floor(time / 60),
        minutes: time % 60,
    };
};
exports.getStringValue = function (value, max) {
    var time = exports.getValue(value, max);
    return exports.convertToTimeLabel(time.hours, time.minutes);
};
exports.convertTimeToSliderValue = function (time, max) {
    var hourValue = Math.floor((max / 24) * time.hours);
    var minuteValue = Math.floor((max / 24 / 60) * time.minutes);
    return hourValue + minuteValue;
};
exports.convertTimesToSliderValue = function (times, max) {
    return times.map(function (time) { return exports.convertTimeToSliderValue(time, max); });
};
exports.generateMarks = function (showMarks, step, max, marksInterval) {
    if (showMarks) {
        if (marksInterval) {
            return generateValues(marksInterval, max);
        }
        return generateValues(step, max);
    }
    return undefined;
};
var generateValues = function (minuteInterval, max) {
    var _a;
    var marks = (_a = {
            0: exports.convertToTimeLabel(0, 0)
        },
        _a[max] = exports.convertToTimeLabel(24, 0),
        _a);
    var value = minuteInterval;
    while (value < max) {
        var time = exports.getValue(value, max);
        marks[value] = exports.convertToTimeLabel(time.hours, time.minutes);
        value = value + minuteInterval;
    }
    return marks;
};
//# sourceMappingURL=sliderUtils.js.map