/// <reference types="recompose" />
import { ComponentThemes } from '../../../themes/theme-types/ComponentThemes';
import { DeepPartial } from '../../../types/DeepPartial';
export interface ComponentThemeProps<T extends keyof ComponentThemes> {
    theme?: DeepPartial<ComponentThemes[T]>;
}
export interface WithInnerComponentThemeProps<T> {
    theme: T;
}
export declare const withComponentTheme: <T extends "Button" | "Calendar" | "DateInput" | "DateRangeInput" | "DefaultText" | "DefaultTextInput" | "FlatButton" | "HeaderText" | "LargeText" | "NumericTextInput" | "RadioButton" | "SectionHeaderText" | "Select" | "SeparatorLine" | "SimpleCheckbox" | "SimpleTextInput" | "Slider" | "SmallButton" | "SmallText" | "SmallerText" | "StandardButton" | "Switch" | "TinyText">(componentName: T) => import("recompose").ComponentEnhancer<WithInnerComponentThemeProps<ComponentThemes[T]>, WithInnerComponentThemeProps<DeepPartial<ComponentThemes[T]>>>;
