"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var recompose_1 = require("recompose");
var GetTheme_1 = require("../../theme/GetTheme");
exports.withTheme = function (WrappedComponent) {
    var WithThemeComponent = /** @class */ (function (_super) {
        tslib_1.__extends(WithThemeComponent, _super);
        function WithThemeComponent() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.renderWrappedComponent = function (theme) {
                return React.createElement(WrappedComponent, tslib_1.__assign({}, _this.props, { theme: theme }));
            };
            return _this;
        }
        WithThemeComponent.prototype.render = function () {
            return React.createElement(GetTheme_1.GetTheme, null, this.renderWrappedComponent);
        };
        return WithThemeComponent;
    }(React.Component));
    return recompose_1.compose(recompose_1.setDisplayName('withTheme()'))(WithThemeComponent);
};
//# sourceMappingURL=WithTheme.js.map