"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var lodash_1 = require("lodash");
var React = require("react");
var Debounce = /** @class */ (function (_super) {
    tslib_1.__extends(Debounce, _super);
    function Debounce(props) {
        var _this = _super.call(this, props) || this;
        _this.funcDebounced = undefined;
        return _this;
    }
    Debounce.prototype.componentWillMount = function () {
        var _a = this.props, func = _a.func, _b = _a.delay, delay = _b === void 0 ? 500 : _b;
        this.funcDebounced = lodash_1.debounce(func, delay);
    };
    Debounce.prototype.render = function () {
        var children = this.props.children;
        return children(this.funcDebounced);
    };
    return Debounce;
}(React.Component));
exports.Debounce = Debounce;
//# sourceMappingURL=Debounce.js.map