"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
exports.useRevertableValue = function (initialValue) {
    var _a = react_1.useState(initialValue), value = _a[0], setValue = _a[1];
    var _b = react_1.useState(initialValue), revertValue = _b[0], setRevertValue = _b[1];
    react_1.useEffect(function () {
        setValue(initialValue);
    }, [setValue, initialValue]);
    var revert = react_1.useCallback(function () {
        if (revertValue) {
            setValue(revertValue);
        }
    }, [setValue, revertValue]);
    var commit = react_1.useCallback(function (commitValue) {
        setRevertValue(value);
        if (commitValue) {
            setValue(commitValue);
        }
    }, [value, setValue]);
    return {
        value: value,
        setValue: setValue,
        setRevertValue: setRevertValue,
        revert: revert,
        commit: commit,
    };
};
//# sourceMappingURL=UseRevertableValue.js.map