"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var NumberBoundsWrapper_1 = require("./NumberBoundsWrapper");
exports.getNextPositionWrappedOrClamped = function (rowIndex, colIndex, numRows, numCols, direction, wrap) {
    var posNotWrapped = exports.getNextPosition(rowIndex, colIndex, direction);
    return wrap
        ? NumberBoundsWrapper_1.wrapPos(posNotWrapped, numRows - 1, numCols - 1)
        : NumberBoundsWrapper_1.clampPos(posNotWrapped, numRows - 1, numCols - 1);
};
exports.getNextPosition = function (rowIndex, colIndex, direction) {
    if (direction === 'up') {
        return {
            rowIndex: rowIndex - 1,
            colIndex: colIndex,
        };
    }
    if (direction === 'down') {
        return {
            rowIndex: rowIndex + 1,
            colIndex: colIndex,
        };
    }
    if (direction === 'left') {
        return {
            rowIndex: rowIndex,
            colIndex: colIndex - 1,
        };
    }
    if (direction === 'right') {
        return {
            rowIndex: rowIndex,
            colIndex: colIndex + 1,
        };
    }
    return {
        rowIndex: rowIndex,
        colIndex: colIndex,
    };
};
//# sourceMappingURL=DirectionCalculator.js.map