import { WhiteSpaceProperty } from 'csstype';
export interface SelectTheme {
    arrowColor: {
        focused: {
            standard: string;
            hover: string;
        };
        closed: {
            standard: string;
            hover: string;
        };
    };
    clearButtonColor: {
        standard: string;
        hover: string;
    };
    input: {
        backgroundColor: string;
        border: string;
        borderFocused: string;
        borderColor: string;
        borderColorFocused: string;
        borderRadius: string;
        disabledBackgroundColor: string;
        fontFamily: string;
        fontSize: string;
        height: string;
        minHeight: string;
        placeholderColor: string;
        textColor: string;
    };
    loadingIndicator: {
        textColor: string;
    };
    menu: {
        disabledTextColor: string;
        disabledBackgroundColor: string | undefined;
        textColor: string;
        backgroundColor: string;
        hoverTextColor: string;
        hoverBackgroundColor: string;
        minWidth?: string;
        selectedItemTextColor: string;
        selectedItemBackgroundColor: string;
        zIndex: number;
        width?: string;
        whiteSpace?: WhiteSpaceProperty;
    };
    menuPortal: {
        zIndex: number;
    };
    multiSelect: {
        backgroundColor: string;
        removeButtonBackgroundColor: string;
        removeButtonTextColor: string;
        removeButtonHoverBackgroundColor: string;
        removeButtonHoverTextColor: string;
    };
}
export declare const defaultSelectTheme: SelectTheme;
export declare const selectThemeDark: SelectTheme;
