"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var DefaultColors_1 = require("../../themes/default-values/DefaultColors");
var DefaultFonts_1 = require("../../themes/default-values/DefaultFonts");
var DefaultFontSizes_1 = require("../../themes/default-values/DefaultFontSizes");
exports.defaultSelectTheme = {
    arrowColor: {
        focused: {
            hover: DefaultColors_1.defaultColors.primaryText,
            standard: DefaultColors_1.defaultColors.separator,
        },
        closed: {
            hover: DefaultColors_1.defaultColors.primaryText,
            standard: DefaultColors_1.defaultColors.separator,
        },
    },
    clearButtonColor: {
        hover: DefaultColors_1.defaultColors.primaryText,
        standard: DefaultColors_1.defaultColors.separator,
    },
    input: {
        backgroundColor: DefaultColors_1.defaultColors.white,
        border: "1px solid " + DefaultColors_1.defaultColors.inputBorder,
        borderFocused: "1px solid " + DefaultColors_1.defaultColors.inputBorderFocused,
        borderColor: DefaultColors_1.defaultColors.inputBorder,
        borderColorFocused: DefaultColors_1.defaultColors.inputBorderFocused,
        disabledBackgroundColor: DefaultColors_1.defaultColors.disabledBackground,
        fontFamily: DefaultFonts_1.defaultFonts.primary,
        fontSize: DefaultFontSizes_1.defaultFontSizes.normal,
        height: '34px',
        minHeight: '34px',
        placeholderColor: DefaultColors_1.defaultColors.separator,
        textColor: DefaultColors_1.defaultColors.primaryText,
        borderRadius: '4px',
    },
    loadingIndicator: {
        textColor: DefaultColors_1.defaultColors.primaryText,
    },
    menu: {
        disabledTextColor: DefaultColors_1.defaultColors.disabledText,
        disabledBackgroundColor: undefined,
        textColor: DefaultColors_1.defaultColors.primaryText,
        backgroundColor: DefaultColors_1.defaultColors.white,
        hoverTextColor: DefaultColors_1.defaultColors.primaryText,
        hoverBackgroundColor: '#F2F3F5',
        selectedItemTextColor: DefaultColors_1.defaultColors.primaryText,
        selectedItemBackgroundColor: '#B9D8DF',
        zIndex: 1,
    },
    menuPortal: {
        zIndex: 1,
    },
    multiSelect: {
        backgroundColor: '#B9D8DF',
        removeButtonBackgroundColor: '#B9D8DF',
        removeButtonTextColor: DefaultColors_1.defaultColors.primaryText,
        removeButtonHoverBackgroundColor: DefaultColors_1.defaultColors.primaryBgDark,
        removeButtonHoverTextColor: DefaultColors_1.defaultColors.white,
    },
};
exports.selectThemeDark = {
    arrowColor: {
        focused: {
            hover: DefaultColors_1.defaultColors.white,
            standard: DefaultColors_1.defaultColors.separator,
        },
        closed: {
            hover: DefaultColors_1.defaultColors.white,
            standard: DefaultColors_1.defaultColors.separator,
        },
    },
    clearButtonColor: {
        standard: DefaultColors_1.defaultColors.separator,
        hover: DefaultColors_1.defaultColors.white,
    },
    input: {
        backgroundColor: '#4a5d73',
        border: '1px solid transparent',
        borderFocused: "1px solid #92a3b5",
        borderColor: 'transparent',
        borderColorFocused: '#92a3b5',
        disabledBackgroundColor: DefaultColors_1.defaultColors.disabledBackground,
        fontFamily: DefaultFonts_1.defaultFonts.primary,
        fontSize: DefaultFontSizes_1.defaultFontSizes.normal,
        height: '34px',
        minHeight: '34px',
        placeholderColor: DefaultColors_1.defaultColors.white,
        textColor: DefaultColors_1.defaultColors.white,
        borderRadius: '4px',
    },
    loadingIndicator: {
        textColor: DefaultColors_1.defaultColors.white,
    },
    menu: {
        disabledTextColor: DefaultColors_1.defaultColors.disabledText,
        disabledBackgroundColor: undefined,
        backgroundColor: '#4a5d73',
        textColor: DefaultColors_1.defaultColors.white,
        hoverTextColor: DefaultColors_1.defaultColors.white,
        hoverBackgroundColor: '#6F7E90',
        selectedItemTextColor: '#226F81',
        selectedItemBackgroundColor: '#B9D8DF',
        zIndex: 1,
    },
    menuPortal: {
        zIndex: 1,
    },
    multiSelect: {
        backgroundColor: '#B9D8DF',
        removeButtonBackgroundColor: '#B9D8DF',
        removeButtonTextColor: DefaultColors_1.defaultColors.primaryText,
        removeButtonHoverBackgroundColor: DefaultColors_1.defaultColors.primaryBgDark,
        removeButtonHoverTextColor: DefaultColors_1.defaultColors.white,
    },
};
//# sourceMappingURL=SelectTheme.js.map