import { ComponentEnhancer } from 'recompose';
import { CellIdGenerator, EditingHandlers, InjectedOnFocusProps, WithEditingStateProps, WithIsEditableProps } from './internal/WithEditStateHandler';
import { NavigationMoveDirection, WithKeyDownHandlerInnerProps, WithKeyDownHandlerOuterProps } from './internal/WithNavigatableKeyDownHandler';
export declare type __C9134T = ComponentEnhancer<{}, {}>;
export declare const withTableNavigation: <T, OuterProps extends RequiredTableCellOuterProps<T>>(type: import("../index").AllowedInputType, getCellId: CellIdGenerator) => ComponentEnhancer<{}, {}>;
export interface TableOnCellMoveEvent {
    fromRowIndex: number;
    fromColumnIndex: number;
    rowChange: boolean;
    columnChange: boolean;
    rowIndex: number;
    columnIndex: number;
}
export interface OnCellFocusEvent {
    rowIndex: number;
    columnIndex: number;
}
export interface RequiredTableCellOuterProps<T> extends WithIsEditableProps {
    columnIndex: number;
    rowIndex: number;
    numColumns: number;
    numRows: number;
    value: T;
    onCellMove?: (event: TableOnCellMoveEvent) => void;
    onCellFocus?: (event: OnCellFocusEvent) => void;
}
export declare type InjectedTableInnerProps<T> = WithKeyDownHandlerInnerProps & WithKeyDownHandlerOuterProps<T> & EditingHandlers & WithEditingStateProps & InjectedOnFocusProps;
export interface InputComponentProps {
    onMove?: (direction: NavigationMoveDirection) => void;
    onDblClick?: () => void;
    onStartEdit?: (enteredString: string) => void;
    onDone?: () => void;
    onDoneAndStay?: () => void;
    onEsc?: () => void;
}
