import { FocusEventHandler } from 'react';
import { ComponentEnhancer, InferableComponentEnhancerWithProps } from 'recompose';
import { RequiredTableCellOuterProps } from '../WithTableNavigation';
import { NavigationMoveDirection } from './WithNavigatableKeyDownHandler';
export declare type __C81458 = ComponentEnhancer<{}, {}> & InferableComponentEnhancerWithProps<{}, {}>;
export declare type CellIdGenerator = (col: number, row: number) => string;
export interface TableCellIndices {
    columnIndex: number;
    rowIndex: number;
}
export interface OuterTableProps<T> {
    columnIndex: number;
    rowIndex: number;
    numColumns: number;
    numRows: number;
    value: T;
}
export interface InjectedOnFocusProps {
    onFocus?: FocusEventHandler<HTMLDivElement>;
}
export declare const withOnFocus: InferableComponentEnhancerWithProps<InjectedOnFocusProps & RequiredTableCellOuterProps<{}>, RequiredTableCellOuterProps<{}>>;
export interface WithEditingStateProps {
    isEditing: boolean;
    enteredText: string;
    setIsEditing: (isEditing: boolean) => void;
    setEnteredText: (enteredText: string) => void;
}
export interface WithEditingHandlersProps {
    onMove: (direction: NavigationMoveDirection) => void;
    onDblClick: () => void;
    onStartEdit: (enteredText: string) => void;
    onDoneAndStay: () => void;
    onDone: () => void;
    onEsc: () => void;
}
export interface WithIsEditableProps {
    isEditable: boolean;
}
export declare const withEditingState: ComponentEnhancer<{}, {}>;
export interface EditingHandlers {
    onMove: (direction: NavigationMoveDirection) => void;
    onDblClick: () => void;
    onStartEdit: (enteredString: string) => void;
    onDone: () => void;
    onDoneAndStay: () => void;
    onEsc: () => void;
}
export declare const withEditingHandlers: <T, OuterProps extends RequiredTableCellOuterProps<T>>(getCellId: CellIdGenerator) => InferableComponentEnhancerWithProps<EditingHandlers & OuterProps & WithEditingStateProps, OuterProps & WithEditingStateProps>;
