import { KeyboardEventHandler } from 'react';
import { InferableComponentEnhancerWithProps } from 'recompose';
import { OuterTableProps } from './WithEditStateHandler';
export declare type __C183457 = InferableComponentEnhancerWithProps<{}, {}>;
export declare type AllowedType = 'all' | 'numeric' | 'alphanumeric' | 'letters';
export declare type NavigationMoveDirection = 'up' | 'down' | 'left' | 'right';
export declare type NavigatableKeyDownHandlerOnMove = (direction: NavigationMoveDirection) => void;
export interface WithKeyDownHandlerOuterProps<T> extends OuterTableProps<T> {
    onMove: NavigatableKeyDownHandlerOnMove;
    onStartEdit: (enteredText?: string) => void;
    isEditing: boolean;
    isEditable: boolean;
}
export interface WithKeyDownHandlerInnerProps {
    onKeyDown: KeyboardEventHandler<HTMLDivElement>;
}
export interface WithKeyDownHandlerOptions {
    type?: AllowedType;
}
export declare const withNavigatableKeyDownHandler: <T>({ type, }: WithKeyDownHandlerOptions) => InferableComponentEnhancerWithProps<WithKeyDownHandlerInnerProps & WithKeyDownHandlerOuterProps<T>, WithKeyDownHandlerOuterProps<T>>;
