"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var recompose_1 = require("recompose");
exports.withNavigatableKeyDownHandler = function (_a) {
    var type = _a.type;
    return recompose_1.withHandlers({
        onKeyDown: function (_a) {
            var onMove = _a.onMove, onStartEdit = _a.onStartEdit, isEditing = _a.isEditing, isEditable = _a.isEditable;
            return function (e) {
                if (!isEditing) {
                    if (e.key === 'Enter' && isEditable) {
                        onStartEdit();
                        e.preventDefault();
                        e.stopPropagation();
                    }
                    else if (e.key === 'Tab' && e.shiftKey) {
                        onMove('left');
                        e.preventDefault();
                        e.stopPropagation();
                    }
                    else if (e.key === 'Tab') {
                        onMove('right');
                        e.preventDefault();
                        e.stopPropagation();
                    }
                    else if (e.key === 'ArrowLeft') {
                        onMove('left');
                        e.preventDefault();
                        e.stopPropagation();
                    }
                    else if (e.key === 'ArrowUp') {
                        onMove('up');
                        e.preventDefault();
                        e.stopPropagation();
                    }
                    else if (e.key === 'ArrowRight') {
                        onMove('right');
                        e.preventDefault();
                        e.stopPropagation();
                    }
                    else if (e.key === 'ArrowDown') {
                        onMove('down');
                        e.preventDefault();
                        e.stopPropagation();
                    }
                    else if (!e.shiftKey &&
                        !e.ctrlKey &&
                        !e.altKey &&
                        !e.metaKey &&
                        isEditable) {
                        var num = parseInt(e.key, 10);
                        if (!isNaN(num)) {
                            if (type === 'all' ||
                                type === 'numeric' ||
                                type === 'alphanumeric') {
                                onStartEdit(e.key);
                                e.preventDefault();
                                e.stopPropagation();
                            }
                        }
                        else if (type === 'all' ||
                            type === 'alphanumeric' ||
                            type === 'letters') {
                            onStartEdit(e.key);
                            e.preventDefault();
                            e.stopPropagation();
                        }
                    }
                }
            };
        },
    });
};
//# sourceMappingURL=WithNavigatableKeyDownHandler.js.map