"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var TimeTransformer_1 = require("./TimeTransformer");
exports.transformTimeIntervalToNumbers = function (interval) { return ({
    startTime: TimeTransformer_1.transformTimeStringToNumber(interval.startTime),
    endTime: TimeTransformer_1.transformTimeStringToNumber(interval.endTime),
}); };
exports.timesOverlap = function (i1, i2) {
    if (i1.startTime == null ||
        i1.endTime == null ||
        i2.startTime == null ||
        i2.endTime == null) {
        throw new Error('Invalid interval.');
    }
    return i1.startTime <= i2.endTime && i1.endTime >= i2.startTime;
};
exports.hasOverlappingTimes = function (intervals) {
    for (var i = 0; i < intervals.length - 1; i++) {
        for (var j = i + 1; j < intervals.length; j++) {
            if (exports.timesOverlap(intervals[i], intervals[j])) {
                return true;
            }
        }
    }
    return false;
};
//# sourceMappingURL=OverlappingTimesValidator.js.map